/* $Filename:		WormWars/Source/WormWars.h $
 * $VER:		3.1 $
 * $Date:		16 Apr 1996 $
 * $Description:	Header file for WormWars.c $
 *
 *  Copyright 1993-1996 James R. Jacobs of Amigan Software.
 * Freely distributable.
 *
 * Release version.
 *
 * Worm Wars is written completely in SAS/C V6.3. I am not proud of the
 * coding, but it does the job. It is not very much optimised so some
 * significant efficiency increases are possible. The comments are fairly
 * sparse but the code should be reasonably self-explanatory.
 *     Before changing constants check through the code for hardwired
 * dependancies.

miscellaneous */

#define ILLEGAL			((APTR) 0xA9A9)
#define X			7
#define Y			6
#define FIELDX			49
#define FIELDY			38
#define NUMKEYS			31
#define POWERMAX		6
#define STARTXPIXEL		144
#define STARTYPIXEL		10
#define ENDXPIXEL		((STARTXPIXEL + X * (FIELDX + 1)) - 1)
#define ENDYPIXEL		((STARTYPIXEL + Y * (FIELDY + 1)) - 1)
#define CAUSEWAIT		5
#define TELFREQ			120
#define TELEPORTS		3
#define JUSTLIFTED		2
#define VERYTRUE		2
#define SPACEBAR		0x40
#define SENTINEL		2
#define ANIMDELAY		60000
#define VIEWFRAMES		27
#define PROTECTORS		3
#define LEVELS			10
#define DELAY			(16000 - (level * 400))
#define MAXROUNDS		6
#define MAXLIVES		6
#define KILLERS			8
#define KILLERFREQ		80
#define KILLERFIREFREQ		4
#define ORBS			6
#define ORBFREQ			80
#define AMIGASKILL		5	// higher the less mistakes
#define LOOKAHEAD		10	// how many squares the Amiga
					// will look ahead

// object powers

#define MODEADD			20
#define MODERAND		10
#define ICEADD			 5
#define ICERAND			10
#define BOMBADD			 5
#define BOMBRAND		25

/* field values

There are some assumptions made in the code about the values of certain
constants:

Objects start at 0.
FIRSTHARD <= hard barriers <= LASTHARD < soft barriers <= LASTSOFT
Any worm-numbered object (eg. GREENHEAD) is part of a consecutive set for
	all the worms; eg. GREENHEAD, REDHEAD, BLUEHEAD, YELLOWHEAD, and
	thus can be indexed by, eg. GREENHEAD + <worm number>. Note that
	GREENwhatever must be the first, YELLOWwhatever the last, and
	the others can be in any order.
The values of EXIT, PAUSE and MUSIC must be equal to their array indices
	in key[], and cannot be NULL.
The value of NORMAL must not be equal to BLACK or WHITE, nor to GOLD,
	SILVER, EMPTY, BRICK or WALL.
Some constants (eg. PROTECTORS) are the true number - 1 (eg. PROTECTORS
	is 3 but there are 4 protectors) while others are just the true
	number.

*/

#define BONUS			 0
#define AMMO			 1
#define ARMOUR			 2
#define TONGUE			 3
#define NITRO			 4
#define BOMB			 5
#define SLAYER			 6
#define PROTECTOR		 7
#define POWER			 8
#define MISSILE			 9
#define LIFE			10
#define MULTIPLIER		11
#define ICE			12
#define EATER			13
#define BIAS			14
#define DIAGONAL		15
#define GROWER			16
#define LASTOBJECT		GROWER

#define TELEPORT		(LASTOBJECT + 1)

#define EMPTY			(LASTOBJECT + 2)
#define SILVER			(LASTOBJECT + 3)
#define GOLD			(LASTOBJECT + 4)

#define GREEN_C			(LASTOBJECT + 5)
#define RED_O			(LASTOBJECT + 6)
#define BLUE_M			(LASTOBJECT + 7)
#define YELLOW_P		(LASTOBJECT + 8)
#define GREEN_L			(LASTOBJECT + 9)
#define RED_E			(LASTOBJECT + 10)
#define BLUE_T			(LASTOBJECT + 11)
#define YELLOW_E		(LASTOBJECT + 12)
#define FIRSTLETTER		GREEN_C
#define LASTLETTER		YELLOW_E
#define LETTERS			(YELLOW_E - GREEN_C + 1)

#define WALL			(LASTOBJECT + 13)
#define KILLER			(LASTOBJECT + 14)
#define BRICK			(LASTOBJECT + 15)
#define GREENTAIL		(LASTOBJECT + 16)
#define REDTAIL			(LASTOBJECT + 17)
#define BLUETAIL		(LASTOBJECT + 18)
#define YELLOWTAIL		(LASTOBJECT + 19)
#define FIRSTHARD		WALL
#define LASTHARD		KILLER
#define LASTSOFT		YELLOWTAIL

#define ORB			(LASTOBJECT + 20)
#define ORBEATER		(LASTOBJECT + 21)
#define ORBTONGUE		(LASTOBJECT + 22)
#define ORBARMOUR		(LASTOBJECT + 23)
#define FRAGMENT		(LASTOBJECT + 24)
#define FIRE			(LASTOBJECT + 25)
#define GREENFIRE		(LASTOBJECT + 26)
#define REDFIRE			(LASTOBJECT + 27)
#define BLUEFIRE		(LASTOBJECT + 28)
#define YELLOWFIRE		(LASTOBJECT + 29)
#define GREENPROTECTOR		(LASTOBJECT + 30)
#define REDPROTECTOR		(LASTOBJECT + 31)
#define BLUEPROTECTOR		(LASTOBJECT + 32)
#define YELLOWPROTECTOR		(LASTOBJECT + 33)
#define GREENMISSILE		(LASTOBJECT + 34)
#define REDMISSILE		(LASTOBJECT + 35)
#define BLUEMISSILE		(LASTOBJECT + 36)
#define YELLOWMISSILE		(LASTOBJECT + 37)
#define SKULL			(LASTOBJECT + 38)
#define MUZAK			(LASTOBJECT + 39)

#define GREENHEADSTART		(LASTOBJECT + 40)
#define GREENHEADUP		GREENHEADSTART
#define GREENHEADLEFT		(GREENHEADSTART +  1)
#define GREENHEADRIGHT		(GREENHEADSTART +  2)
#define GREENHEADDOWN		(GREENHEADSTART +  3)
#define GREENTONGUEUP		(GREENHEADSTART +  4)
#define GREENTONGUELEFT		(GREENHEADSTART +  5)
#define GREENTONGUERIGHT	(GREENHEADSTART +  6)
#define GREENTONGUEDOWN		(GREENHEADSTART +  7)
#define GREENEATERUP		(GREENHEADSTART +  8)
#define GREENEATERLEFT		(GREENHEADSTART +  9)
#define GREENEATERRIGHT		(GREENHEADSTART + 10)
#define GREENEATERDOWN		(GREENHEADSTART + 11)
#define GREENARMOURUP		(GREENHEADSTART + 12)
#define GREENARMOURLEFT		(GREENHEADSTART + 13)
#define GREENARMOURRIGHT	(GREENHEADSTART + 14)
#define GREENARMOURDOWN		(GREENHEADSTART + 15)

#define REDHEADSTART		(GREENARMOURDOWN + 1)
#define REDHEADUP		REDHEADSTART
#define REDHEADLEFT		(REDHEADSTART +  1)
#define REDHEADRIGHT		(REDHEADSTART +  2)
#define REDHEADDOWN		(REDHEADSTART +  3)
#define REDTONGUEUP		(REDHEADSTART +  4)
#define REDTONGUELEFT		(REDHEADSTART +  5)
#define REDTONGUERIGHT		(REDHEADSTART +  6)
#define REDTONGUEDOWN		(REDHEADSTART +  7)
#define REDEATERUP		(REDHEADSTART +  8)
#define REDEATERLEFT		(REDHEADSTART +  9)
#define REDEATERRIGHT		(REDHEADSTART + 10)
#define REDEATERDOWN		(REDHEADSTART + 11)
#define REDARMOURUP		(REDHEADSTART + 12)
#define REDARMOURLEFT		(REDHEADSTART + 13)
#define REDARMOURRIGHT		(REDHEADSTART + 14)
#define REDARMOURDOWN		(REDHEADSTART + 15)

#define BLUEHEADSTART		(REDARMOURDOWN + 1)
#define BLUEHEADUP		BLUEHEADSTART
#define BLUEHEADLEFT		(BLUEHEADSTART +  1)
#define BLUEHEADRIGHT		(BLUEHEADSTART +  2)
#define BLUEHEADDOWN		(BLUEHEADSTART +  3)
#define BLUETONGUEUP		(BLUEHEADSTART +  4)
#define BLUETONGUELEFT		(BLUEHEADSTART +  5)
#define BLUETONGUERIGHT		(BLUEHEADSTART +  6)
#define BLUETONGUEDOWN		(BLUEHEADSTART +  7)
#define BLUEEATERUP		(BLUEHEADSTART +  8)
#define BLUEEATERLEFT		(BLUEHEADSTART +  9)
#define BLUEEATERRIGHT		(BLUEHEADSTART + 10)
#define BLUEEATERDOWN		(BLUEHEADSTART + 11)
#define BLUEARMOURUP		(BLUEHEADSTART + 12)
#define BLUEARMOURLEFT		(BLUEHEADSTART + 13)
#define BLUEARMOURRIGHT		(BLUEHEADSTART + 14)
#define BLUEARMOURDOWN		(BLUEHEADSTART + 15)

#define YELLOWHEADSTART		(BLUEARMOURDOWN + 1)
#define YELLOWHEADUP		YELLOWHEADSTART
#define YELLOWHEADLEFT		(YELLOWHEADSTART +  1)
#define YELLOWHEADRIGHT		(YELLOWHEADSTART +  2)
#define YELLOWHEADDOWN		(YELLOWHEADSTART +  3)
#define YELLOWTONGUEUP		(YELLOWHEADSTART +  4)
#define YELLOWTONGUELEFT	(YELLOWHEADSTART +  5)
#define YELLOWTONGUERIGHT	(YELLOWHEADSTART +  6)
#define YELLOWTONGUEDOWN	(YELLOWHEADSTART +  7)
#define YELLOWEATERUP		(YELLOWHEADSTART +  8)
#define YELLOWEATERLEFT		(YELLOWHEADSTART +  9)
#define YELLOWEATERRIGHT	(YELLOWHEADSTART + 10)
#define YELLOWEATERDOWN		(YELLOWHEADSTART + 11)
#define YELLOWARMOURUP		(YELLOWHEADSTART + 12)
#define YELLOWARMOURLEFT	(YELLOWHEADSTART + 13)
#define YELLOWARMOURRIGHT	(YELLOWHEADSTART + 14)
#define YELLOWARMOURDOWN	(YELLOWHEADSTART + 15)

#define ARRAYSIZE       YELLOWARMOURDOWN
#define ANYTHING	MUZAK
#define GREENHEAD	(ARRAYSIZE + 1)
#define REDHEAD		(ARRAYSIZE + 2)
#define BLUEHEAD	(ARRAYSIZE + 3)
#define YELLOWHEAD	(ARRAYSIZE + 4)
#define FIREDMISSILE	(ARRAYSIZE + 5)
#define TEMPSILVER	(ARRAYSIZE + 6)
#define TEMPGOLD	(ARRAYSIZE + 7)
#define HEAD		GREENHEAD
#define DESCRIPTIONS	GOLD
#define FIRSTEMPTY	EMPTY
#define LASTEMPTY	GOLD

// colours

#define BLACK		 0
#define WHITE		 1
#define GREY		 2
#define PURPLE		 7

#define GREEN		11
#define RED		 9
#define BLUE		13
#define YELLOW		15

// speed

#define VERYFAST         1
#define FAST             2
#define NORMAL           4
#define SLOW             8
#define VERYSLOW        16

// game status

#define GAMEOVER        0
#define PLAYGAME        1
#define FIELDEDIT	2

// warning codes

#define NOPORT		101
#define NOREQUEST	102
#define NODEVICE	103
#define NOAVAIL		104
#define NOLIBRARY	105
#define NOCHANNELS	106

// status lines

#define SCORELINE	 0
#define LIVESLINE	 1
#define BIASLINE	 2
#define AMMOLINE	 4
#define POWERLINE	 5
#define ARMOURLINE	 7
#define TONGUELINE	 8
#define EATERLINE	 9
#define SPEEDLINE	11
#define DIAGONALLINE	12

// skill points

#define EMPTYPOINT	      1
#define EATYOURTAIL	     50
#define EATOTHERTAIL	    100
#define SILVERPOINT	    100
#define KILLORB		    200
#define TELPOINT	    400
#define GOLDPOINT	    500
#define HITSHOT             500
#define KILLKILLER	    500
#define KILLWORM	   1000
#define CROSSHEADS	   1000
#define SKULLPOINT	   1000
#define YOURLETTER	   1000
#define MYLETTER	   2000
#define WINGAME            5000
#define LEVELBONUS	  10000
#define CHAMPION	1000000

// key values

#define PAUSE            4
#define MUSIC		11
#define EXIT            27
#define TRAINER		28

// scancodes

#define N		54	// new
#define R		19	// revert
#define S		33	// save 
#define DELETE		70
#define HELP	 	95

// control values

#define NONE		0
#define HUMAN           1
#define AMIGA           2

UWORD chip JImageData[][Y * 4] =
{	{	0x0000,		// BONUS
		0x0600,
		0x0000,
		0x1800,
		0xf000,
		0x0000,
		0x0000,
		0x0000,
		0x0c00,
		0x1800,
		0xc000,
		0x6000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0xf000,
		0x7000,
		0x0200,
		0x0600,
		0x0c00,
		0x1800,
		0xf000,
		0x6000
	},
	{	0x3000,		// AMMO
		0x0000,
		0x3000,
		0x0000,
		0x3000,
		0x0000,
		0x3000,
		0x3000,
		0x3000,
		0x3000,
		0x3000,
		0x7800,
		0x3000,
		0x3000,
		0x3000,
		0x3000,
		0x3000,
		0x7800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x0000,		// ARMOUR
		0x7C00,
		0xFE00,
		0x9200,
		0x9200,
		0xFE00,
		0x0000,
		0x7C00,
		0xFE00,
		0x9200,
		0x9200,
		0xFE00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x0000,		// TONGUE
		0x3800,
		0x7C00,
		0xFE00,
		0x9200,
		0xFE00,
		0x0000,
		0x3800,
		0x7C00,
		0x9200,
		0x9200,
		0xFE00,
		0x0000,
		0x3800,
		0x7C00,
		0x9200,
		0x9200,
		0xFE00,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x0000,		// NITRO
		0x0000,
		0x7C00,
		0x1000,
		0x1000,
		0x1000,
		0x1000,
		0x0000,
		0x7C00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x0C00,		// BOMB
		0x0C00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0xFE00,
		0xFE00,
		0xC600,
		0x8200,
		0xC600,
		0xFE00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x1000,		// SLAYER
		0x8200,
		0x0000,
		0x0000,
		0x8200,
		0x1000,
		0x1000,
		0x8200,
		0x3800,
		0x3800,
		0x8200,
		0x1000,
		0x1000,
		0x8200,
		0x3800,
		0x3800,
		0x8200,
		0x1000,
		0x1000,
		0x8200,
		0x3800,
		0x3800,
		0x8200,
		0x1000
	},
	{	0x0000,		// PROTECTOR
		0x4400,
		0x0000,
		0x4400,
		0x3800,
		0x0000,
		0x7C00,
		0xBA00,
		0xFE00,
		0xBA00,
		0x4400,
		0x3800,
		0x7C00,
		0xBA00,
		0xFE00,
		0xBA00,
		0x4400,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x1000,		// POWER
		0x7000,
		0xF000,
		0x1E00,
		0x1C00,
		0x1000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x1000,
		0x7C00,
		0xFE00,
		0xFE00,
		0x7C00,
		0x1000,
		0x1000,
		0x7000,
		0xF000,
		0x1E00,
		0x1C00,
		0x1000
	},
	{	0x8600,		// MISSILE
		0x8800,
		0x5000,
		0x3C00,
		0x1200,
		0xE100,
		0x8600,
		0x8800,
		0x5000,
		0x3C00,
		0x1200,
		0xE100,
		0x8600,
		0x8800,
		0x5000,
		0x3C00,
		0x1200,
		0xE100,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x4400,		// LIFE
		0xAA00,
		0x9200,
		0x4400,
		0x2800,
		0x1000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x4400,
		0xEE00,
		0xFE00,
		0x7C00,
		0x3800,
		0x1000
	},
	{	0x0000,		// MULTIPLIER
		0x0000,
		0x3000,
		0x4400,
		0x1800,
		0x7C00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x4800,
		0x3000,
		0x4800,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x0000,		// ICE
		0x0000,
		0x0200,
		0xFE00,
		0xFC00,
		0xF800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x3E00,
		0x7E00,
		0xFE00,
		0xFC00,
		0xF800,
		0x0000,
		0x0000,
		0x0200,
		0x0600,
		0x0400,
		0x0000
	},
	{	0x8200,		// EATER
		0xC600,
		0xFE00,
		0xFE00,
		0x9200,
		0xFE00,
		0x8200,
		0xC600,
		0xFE00,
		0x9200,
		0x9200,
		0xFE00,
		0x8200,
		0xC600,
		0xFE00,
		0x9200,
		0x9200,
		0xFE00,
		0x0000,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x0000,		// BIAS
		0x1000,
		0x3800,
		0x3800,
		0x7C00,
		0x0000,
		0x0000,
		0x1000,
		0x3800,
		0x3800,
		0x7C00,
		0x0000,
		0x0000,
		0x1000,
		0x3800,
		0x3800,
		0x7C00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x3000,		// DIAGONAL
		0x7C00,
		0xFE00,
		0xF200,
		0x4E00,
		0x3E00,
		0x3000,
		0x7C00,
		0xF200,
		0xC200,
		0x4E00,
		0x3E00,
		0x3000,
		0x7C00,
		0xF200,
		0xC200,
		0x4E00,
		0x3E00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x7E00,		// GROWER
		0x9000,
		0x7C00,
		0x1200,
		0xFC00,
		0x1000,
		0x7E00,
		0x9000,
		0x7C00,
		0x1200,
		0xFC00,
		0x1000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x7E00,
		0x9000,
		0x7C00,
		0x1200,
		0xFC00,
		0x1000
	},
	{	0x0000,		// TELEPORT
		0x0000,
		0x0000,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0x0000,
		0xFE00,
		0xFE00,
		0x0000,
		0x0000,
		0x0000,
		0xFE00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0xFE00,
		0x0000,
		0x0000,
		0x0000
	},
	{	0xFE00,		// EMPTY
		0x8000,
		0x8000,
		0x8000,
		0x8000,
		0x8000,
		0xFE00,
		0x8200,
		0x8200,
		0x8200,
		0x8200,
		0xFE00,
		0x0000,
		0x7C00,
		0x7C00,
		0x7C00,
		0x7C00,
		0x0000,
		0x0000,
		0x7C00,
		0x7C00,
		0x7C00,
		0x7C00,
		0x0000
	},
	{	0xFE00,		// SILVER
		0xFC00,
		0xFC00,
		0xFC00,
		0xFC00,
		0x8000,
		0x0000,
		0x7E00,
		0x7E00,
		0x7E00,
		0x7E00,
		0x7E00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0xFC00,		// GOLD
		0x8000,
		0x8000,
		0x8000,
		0x8000,
		0x8000,
		0x0200,
		0x7E00,
		0x7E00,
		0x7E00,
		0x7E00,
		0x7E00,
		0x0200,
		0x7E00,
		0x7E00,
		0x7E00,
		0x7E00,
		0x7E00,
		0x0200,
		0x7E00,
		0x7E00,
		0x7E00,
		0x7E00,
		0x7E00
	},
	{	0x3FFF,		// GREEN_C
		0x41FF,
		0x81FF,
		0x81FF,
		0x41FF,
		0x3FFF,
		0xC000,
		0xBE00,
		0x7E00,
		0x7E00,
		0xBE00,
		0xC000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0xC1FF,
		0xBFFF,
		0x7FFF,
		0x7FFF,
		0xBFFF,
		0xC1FF
	},
	{	0x3800,		// RED_O
		0xC400,
		0x8200,
		0x8200,
		0x4400,
		0x3800,
		0x01FF,
		0x01FF,
		0x01FF,
		0x01FF,
		0x01FF,
		0x01FF,
		0x01FF,
		0x01FF,
		0x01FF,
		0x01FF,
		0x01FF,
		0x01FF,
		0xC7FF,
		0x3BFF,
		0x7DFF,
		0x7DFF,
		0xBBFF,
		0xC7FF
	},
	{	0x8200,		// BLUE_M
		0xC600,
		0xAA00,
		0x9200,
		0x8200,
		0x8200,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x7C00,
		0x3800,
		0x5400,
		0x6C00,
		0x7C00,
		0x7C00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0xFC00,		// YELLOW_P
		0x8200,
		0xFC00,
		0x8000,
		0x8000,
		0x8000,
		0x0200,
		0x7C00,
		0x0200,
		0x7E00,
		0x7E00,
		0x7E00,
		0x0200,
		0x7C00,
		0x0200,
		0x7E00,
		0x7E00,
		0x7E00,
		0x0200,
		0x7C00,
		0x0200,
		0x7E00,
		0x7E00,
		0x7E00
	},
	{	0x8000,		// GREEN_L
		0x8000,
		0x8000,
		0x8000,
		0x8000,
		0xFE00,
		0x7E00,
		0x7E00,
		0x7E00,
		0x7E00,
		0x7E00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x7E00,
		0x7E00,
		0x7E00,
		0x7E00,
		0x7E00,
		0x0000
	},
	{	0xFE00,		// RED_E
		0x8000,
		0xF000,
		0x8000,
		0x8000,
		0xFC00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x7E00,
		0x0E00,
		0x7E00,
		0x7E00,
		0x0200
	},
	{	0xFE00,		// BLUE_T
		0x1000,
		0x1000,
		0x1000,
		0x1000,
		0x1000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0xEE00,
		0xEE00,
		0xEE00,
		0xEE00,
		0xEE00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0xFE00,		// YELLOW_E
		0x8000,
		0xF000,
		0x8000,
		0x8000,
		0xFE00,
		0x0000,
		0x7E00,
		0x0E00,
		0x7E00,
		0x7E00,
		0x0000,
		0x0000,
		0x7E00,
		0x0E00,
		0x7E00,
		0x7E00,
		0x0000,
		0x0000,
		0x7E00,
		0x0E00,
		0x7E00,
		0x7E00,
		0x0000
	},
	{	0xFE00,		// WALL
		0x8000,
		0x8000,
		0x8000,
		0x8000,
		0x8000,
		0x0000,
		0x0200,
		0x0200,
		0x0200,
		0x0200,
		0x7E00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x0000,		// KILLER
		0x0000,
		0x0000,
		0x0000,
		0x2800,
		0x0000,
		0x3800,
		0x3800,
		0x3800,
		0x7C00,
		0xD600,
		0x7C00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x3800,
		0x3800,
		0x3800,
		0x7C00,
		0xD600,
		0x7C00
	},
	{	0xFE00,		// BRICK
		0x8000,
		0x8000,
		0x8000,
		0x8000,
		0x8000,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0xFE00,		// GREENTAIL
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00
	},
	{	0xFE00,		// REDTAIL
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00
	},
	{	0xFE00,		// BLUETAIL
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0xFE00,		// YELLOWTAIL
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00,
		0xFE00
	},
	{	0x0000,		// ORB
		0x0000,
		0x3800,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x3800,
		0x7C00,
		0x7C00,
		0x3800,
		0x0000,
		0x0000,
		0x3800,
		0x7C00,
		0x7C00,
		0x3800,
		0x0000,
		0x0000,
		0x3800,
		0x7C00,
		0x7C00,
		0x3800,
		0x0000
	},
	{	0x0000,		// ORBEATER
		0x0000,
		0x3800,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x3800,
		0x7C00,
		0x7C00,
		0x3800,
		0x0000
	},
	{	0x0000,		// ORBTONGUE
		0x0000,
		0x3800,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x3800,
		0x7C00,
		0x7C00,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x0000,		// ORBARMOUR
		0x0000,
		0x3800,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x3800,
		0x7C00,
		0x7C00,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x3800,
		0x7C00,
		0x7C00,
		0x3800,
		0x0000
	},
	{	0x0000,		// FRAGMENT
		0x0000,
		0x0800,
		0x1000,
		0x1000,
		0x0000,
		0x0000,
		0x0000,
		0x0800,
		0x1000,
		0x1000,
		0x0000,
		0x0000,
		0x0000,
		0x1000,
		0x2800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x1000,
		0x2800,
		0x0000,
		0x0000
	},
	{	0x0000,		// FIRE
		0x3800,
		0x3800,
		0x3800,
		0x1000,
		0x0000,
		0x0000,
		0x1800,
		0x1800,
		0x1800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x1800,		// GREENFIRE
		0x0000,
		0x1800,
		0x0000,
		0x1800,
		0x0000,
		0x1800,
		0x1800,
		0x1800,
		0x1800,
		0x1800,
		0x3C00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x1800,
		0x1800,
		0x1800,
		0x1800,
		0x1800,
		0x3C00
	},
	{	0x1800,		// REDFIRE
		0x0000,
		0x1800,
		0x0000,
		0x1800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x1800,
		0x1800,
		0x1800,
		0x1800,
		0x1800,
		0x3C00
	},
	{	0x1800,		// BLUEFIRE
		0x0000,
		0x1800,
		0x0000,
		0x1800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x1800,
		0x1800,
		0x1800,
		0x1800,
		0x1800,
		0x3C00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x1800,		// YELLOWFIRE
		0x0000,
		0x1800,
		0x0000,
		0x1800,
		0x0000,
		0x1800,
		0x1800,
		0x1800,
		0x1800,
		0x1800,
		0x3C00,
		0x1800,
		0x1800,
		0x1800,
		0x1800,
		0x1800,
		0x3C00,
		0x1800,
		0x1800,
		0x1800,
		0x1800,
		0x1800,
		0x3C00
	},
	{	0x0000,		// GREENPROTECTOR
		0x4400,
		0x0000,
		0x4400,
		0x3800,
		0x0000,
		0x7C00,
		0xBA00,
		0xFE00,
		0xBA00,
		0x4400,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x7C00,
		0xBA00,
		0xFE00,
		0xBA00,
		0x4400,
		0x3800
	},
	{	0x0000,		// REDPROTECTOR
		0x4400,
		0x0000,
		0x4400,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x7C00,
		0xBA00,
		0xFE00,
		0xBA00,
		0x4400,
		0x3800
	},
	{	0x0000,		// BLUEPROTECTOR
		0x4400,
		0x0000,
		0x4400,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x7C00,
		0xBA00,
		0xFE00,
		0xBA00,
		0x4400,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x0000,		// YELLOWPROTECTOR
		0x4400,
		0x0000,
		0x4400,
		0x3800,
		0x0000,
		0x7C00,
		0xBA00,
		0xFE00,
		0xBA00,
		0x4400,
		0x3800,
		0x7C00,
		0xBA00,
		0xFE00,
		0xBA00,
		0x4400,
		0x3800,
		0x7C00,
		0xBA00,
		0xFE00,
		0xBA00,
		0x4400,
		0x3800
	},
	{	0x8600,		// GREENMISSILE
		0x8800,
		0x5000,
		0x3C00,
		0x1200,
		0xE100,
		0x8600,
		0x8800,
		0x5000,
		0x3C00,
		0x1200,
		0xE100,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x8600,
		0x8800,
		0x5000,
		0x3C00,
		0x1200,
		0xE100
	},
	{	0x8600,		// REDMISSILE
		0x8800,
		0x5000,
		0x3C00,
		0x1200,
		0xE100,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x8600,
		0x8800,
		0x5000,
		0x3C00,
		0x1200,
		0xE100
	},
	{	0x8600,		// BLUEMISSILE
		0x8800,
		0x5000,
		0x3C00,
		0x1200,
		0xE100,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x8600,
		0x8800,
		0x5000,
		0x3C00,
		0x1200,
		0xE100,
		0x8600,
		0x8800,
		0x5000,
		0x3C00,
		0x1200,
		0xE100
	},
	{	0x8600,		// YELLOWMISSILE
		0x8800,
		0x5000,
		0x3C00,
		0x1200,
		0xE100,
		0x8600,
		0x8800,
		0x5000,
		0x3C00,
		0x1200,
		0xE100,
		0x8600,
		0x8800,
		0x5000,
		0x3C00,
		0x1200,
		0xE100,
		0x8600,
		0x8800,
		0x5000,
		0x3C00,
		0x1200,
		0xE100
	},
	{	0x7C00,		// SKULL
		0x9200,
		0xFE00,
		0xC600,
		0x4400,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x0E00,		// MUZAK
		0x3A00,
		0x2200,
		0x2E00,
		0xEE00,
		0xE000,
		0x0E00,
		0x3A00,
		0x2200,
		0x2E00,
		0xEE00,
		0xE000,
		0x0E00,
		0x3A00,
		0x2200,
		0x2E00,
		0xEE00,
		0xE000,
		0x01FF,
		0x01FF,
		0x01FF,
		0x01FF,
		0x01FF,
		0x01FF
	},
	{	0x0000,		// GREENHEADUP
		0x3800,
		0x7C00,
		0xFE00,
		0x9200,
		0xFE00,
		0x0000,
		0x3800,
		0x7C00,
		0x9200,
		0x9200,
		0xFE00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x3800,
		0x7C00,
		0x9200,
		0x9200,
		0xFE00
	},
	{	0x1E00,		// GREENHEADLEFT
		0x3200,
		0x7E00,
		0x7E00,
		0x3200,
		0x1E00,
		0x1E00,
		0x2200,
		0x7E00,
		0x7E00,
		0x2200,
		0x1E00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x1E00,
		0x2200,
		0x7E00,
		0x7E00,
		0x2200,
		0x1E00
	},
	{	0xF000,		// GREENHEADRIGHT
		0x9800,
		0xFC00,
		0xFC00,
		0x9800,
		0xF000,
		0xF000,
		0x8800,
		0xFC00,
		0xFC00,
		0x8800,
		0xF000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0xF000,
		0x8800,
		0xFC00,
		0xFC00,
		0x8800,
		0xF000
	},
	{	0xFE00,		// GREENHEADDOWN
		0x9200,
		0xFE00,
		0x7C00,
		0x3800,
		0x0000,
		0xFE00,
		0x9200,
		0x9200,
		0x7C00,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0xFE00,
		0x9200,
		0x9200,
		0x7C00,
		0x3800,
		0x0000
	},
	{	0x0000,		// GREENTONGUEUP
		0x1C00,
		0x3E00,
		0x7F00,
		0x4900,
		0x7F00,
		0x0000,
		0x1C00,
		0x3E00,
		0x4900,
		0x4900,
		0x7F00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x1C00,
		0x1C00,
		0x3E00,
		0x4900,
		0x4900,
		0x7F00
	},
	{	0x0F00,		// GREENTONGUELEFT
		0x1900,
		0x3F00,
		0x3F00,
		0x1900,
		0x0F00,
		0x0F00,
		0x1100,
		0x3F00,
		0x3F00,
		0x1100,
		0x0F00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0F00,
		0x1100,
		0x7F00,
		0x7F00,
		0x1100,
		0x0F00
	},
	{	0x7800,		// GREENTONGUERIGHT
		0x4C00,
		0x7E00,
		0x7E00,
		0x4C00,
		0x7800,
		0x7800,
		0x4400,
		0x7E00,
		0x7E00,
		0x4400,
		0x7800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x7800,
		0x4400,
		0x7F00,
		0x7F00,
		0x4400,
		0x7800
	},
	{	0x7F00,		// GREENTONGUEDOWN
		0x4900,
		0x7F00,
		0x3E00,
		0x1C00,
		0x0000,
		0x7F00,
		0x4900,
		0x4900,
		0x3E00,
		0x1C00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x7F00,
		0x4900,
		0x4900,
		0x3E00,
		0x1C00,
		0x1C00
	},
	{	0x4100,		// GREENEATERUP
		0x6300,
		0x7F00,
		0x7F00,
		0x4900,
		0x7F00,
		0x4100,
		0x6300,
		0x7F00,
		0x4900,
		0x4900,
		0x7F00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x4100,
		0x7F00,
		0x7F00,
		0x4900,
		0x4900,
		0x7F00
	},
	{	0x7F00,		// GREENEATERLEFT
		0x3900,
		0x1F00,
		0x1F00,
		0x3900,
		0x7F00,
		0x7F00,
		0x3100,
		0x1F00,
		0x1F00,
		0x3100,
		0x7F00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x7F00,
		0x3100,
		0x3F00,
		0x3F00,
		0x3100,
		0x7F00
	},
	{	0x7F00,		// GREENEATERRIGHT
		0x4E00,
		0x7C00,
		0x7C00,
		0x4E00,
		0x7F00,
		0x7F00,
		0x4600,
		0x7C00,
		0x7C00,
		0x4600,
		0x7F00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x7F00,
		0x4600,
		0x7E00,
		0x7E00,
		0x4600,
		0x7F00
	},
	{	0x7F00,		// GREENEATERDOWN
		0x4900,
		0x7F00,
		0x7F00,
		0x6300,
		0x4100,
		0x7F00,
		0x4900,
		0x4900,
		0x7F00,
		0x6300,
		0x4100,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x7F00,
		0x4900,
		0x4900,
		0x7F00,
		0x7F00,
		0x4100
	},
	{	0x0000,		// GREENARMOURUP
		0x1C00,
		0x3E00,
		0x7F00,
		0x4900,
		0x7F00,
		0x0000,
		0x1C00,
		0x3E00,
		0x4900,
		0x4900,
		0x7F00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x4900,
		0x7F00
	},
	{	0x0F00,		// GREENARMOURLEFT
		0x1900,
		0x3F00,
		0x3F00,
		0x1900,
		0x0F00,
		0x0F00,
		0x1100,
		0x3F00,
		0x3F00,
		0x1100,
		0x0F00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0700,
		0x0100,
		0x0700,
		0x0700,
		0x0100,
		0x0700
	},
	{	0x7800,		// GREENARMOURRIGHT
		0x4C00,
		0x7E00,
		0x7E00,
		0x4C00,
		0x7800,
		0x7800,
		0x4400,
		0x7E00,
		0x7E00,
		0x4400,
		0x7800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x7000,
		0x4000,
		0x7000,
		0x7000,
		0x4000,
		0x7000
	},
	{	0x7F00,		// GREENARMOURDOWN
		0x4900,
		0x7F00,
		0x3E00,
		0x1C00,
		0x0000,
		0x7F00,
		0x4900,
		0x4900,
		0x3E00,
		0x1C00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x7F00,
		0x4900,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x0000,		// REDHEADUP
		0x3800,
		0x7C00,
		0xFE00,
		0x9200,
		0xFE00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x3800,
		0x7C00,
		0x9200,
		0x9200,
		0xFE00
	},
	{	0x1E00,		// REDHEADLEFT
		0x3200,
		0x7E00,
		0x7E00,
		0x3200,
		0x1E00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x1E00,
		0x2200,
		0x7E00,
		0x7E00,
		0x2200,
		0x1E00
	},
	{	0xF000,		// REDHEADRIGHT
		0x9800,
		0xFC00,
		0xFC00,
		0x9800,
		0xF000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0xF000,
		0x8800,
		0xFC00,
		0xFC00,
		0x8800,
		0xF000
	},
	{	0xFE00,		// REDHEADDOWN
		0x9200,
		0xFE00,
		0x7C00,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0xFE00,
		0x9200,
		0x9200,
		0x7C00,
		0x3800,
		0x0000
	},
	{	0x3800,		// REDTONGUEUP
		0x3800,
		0x7C00,
		0xFE00,
		0x9200,
		0xFE00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x3800,
		0x7C00,
		0x9200,
		0x9200,
		0xFE00
	},
	{	0x1E00,		// REDTONGUELEFT
		0x3200,
		0xFE00,
		0xFE00,
		0x3200,
		0x1E00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x8000,
		0x8000,
		0x0000,
		0x0000,
		0x1E00,
		0x2200,
		0x7E00,
		0x7E00,
		0x2200,
		0x1E00
	},
	{	0xF000,		// REDTONGUERIGHT
		0x9800,
		0xFE00,
		0xFE00,
		0x9800,
		0xF000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0200,
		0x0200,
		0x0000,
		0x0000,
		0xF000,
		0x8800,
		0xFC00,
		0xFC00,
		0x8800,
		0xF000
	},
	{	0xFE00,		// REDTONGUEDOWN
		0x9200,
		0xFE00,
		0x7C00,
		0x3800,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x3800,
		0xFE00,
		0x9200,
		0x9200,
		0x7C00,
		0x3800,
		0x0000
	},
	{	0x8200,		// REDEATERUP
		0xFE00,
		0xFE00,
		0xFE00,
		0x9200,
		0xFE00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x8200,
		0xC600,
		0xFE00,
		0x9200,
		0x9200,
		0xFE00
	},
	{	0xFE00,		// REDEATERLEFT
		0x7200,
		0x7E00,
		0x7E00,
		0x7200,
		0xFE00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x4000,
		0x4000,
		0x0000,
		0x0000,
		0xFE00,
		0x6200,
		0x3E00,
		0x3E00,
		0x6200,
		0xFE00
	},
	{	0xFE00,		// REDEATERRIGHT
		0x9C00,
		0xFC00,
		0xFC00,
		0x9C00,
		0xFE00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0400,
		0x0400,
		0x0000,
		0x0000,
		0xFE00,
		0x8C00,
		0xF800,
		0xF800,
		0x8C00,
		0xFE00
	},
	{	0xFE00,		// REDEATERDOWN
		0x9200,
		0xFE00,
		0xFE00,
		0xFE00,
		0x8200,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x3800,
		0x0000,
		0xFE00,
		0x9200,
		0x9200,
		0xFE00,
		0xC600,
		0x8200
	},
	{	0x0000,		// REDARMOURUP
		0x3800,
		0x7C00,
		0xFE00,
		0x9200,
		0xFE00,
		0x0000,
		0x3800,
		0x7C00,
		0x9200,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x9200,
		0xFE00
	},
	{	0x1E00,		// REDARMOURLEFT
		0x3200,
		0x7E00,
		0x7E00,
		0x3200,
		0x1E00,
		0x1000,
		0x2000,
		0x7000,
		0x7000,
		0x2000,
		0x1000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0E00,
		0x0200,
		0x0E00,
		0x0E00,
		0x0200,
		0x0E00
	},
	{	0xF000,		// REDARMOURRIGHT
		0x9800,
		0xFC00,
		0xFC00,
		0x9800,
		0xF000,
		0x1000,
		0x0800,
		0x1C00,
		0x1C00,
		0x0800,
		0x1000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0xE000,
		0x8000,
		0xE000,
		0xE000,
		0x8000,
		0xE000
	},
	{	0xFE00,		// REDARMOURDOWN
		0x9200,
		0xFE00,
		0x7C00,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x9200,
		0x7C00,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0xFE00,
		0x9200,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x0000,		// BLUEHEADUP
		0x3800,
		0x7C00,
		0xFE00,
		0x9200,
		0xFE00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x3800,
		0x7C00,
		0x9200,
		0x9200,
		0xFE00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x1E00,		// BLUEHEADLEFT
		0x3200,
		0x7E00,
		0x7E00,
		0x3200,
		0x1E00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x1E00,
		0x2200,
		0x7E00,
		0x7E00,
		0x2200,
		0x1E00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0xF000,		// BLUEHEADRIGHT
		0x9800,
		0xFC00,
		0xFC00,
		0x9800,
		0xF000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0xF000,
		0x8800,
		0xFC00,
		0xFC00,
		0x8800,
		0xF000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0xFE00,		// BLUEHEADDOWN
		0x9200,
		0xFE00,
		0x7C00,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0xFE00,
		0x9200,
		0x9200,
		0x7C00,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x0000,		// BLUETONGUEUP
		0x3800,
		0x7C00,
		0xFE00,
		0x9200,
		0xFE00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x3800,
		0x7C00,
		0x9200,
		0x9200,
		0xFE00,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x1E00,		// BLUETONGUELEFT
		0x3200,
		0x7E00,
		0x7E00,
		0x3200,
		0x1E00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x1E00,
		0x2200,
		0x7E00,
		0x7E00,
		0x2200,
		0x1E00,
		0x0000,
		0x0000,
		0x8000,
		0x8000,
		0x0000,
		0x0000
	},
	{	0xF000,		// BLUETONGUERIGHT
		0x9800,
		0xFC00,
		0xFC00,
		0x9800,
		0xF000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0xF000,
		0x8800,
		0xFC00,
		0xFC00,
		0x8800,
		0xF000,
		0x0000,
		0x0000,
		0x0200,
		0x0200,
		0x0000,
		0x0000
	},
	{	0xFE00,		// BLUETONGUEDOWN
		0x9200,
		0xFE00,
		0x7C00,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0xFE00,
		0x9200,
		0x9200,
		0x7C00,
		0x3800,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x3800
	},
	{	0x4100,		// BLUEEATERUP
		0x6300,
		0x7F00,
		0x7F00,
		0x4900,
		0x7F00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x4100,
		0x6300,
		0x7F00,
		0x4900,
		0x4900,
		0x7F00,
		0x0000,
		0x1C00,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x7F00,		// BLUEEATERLEFT
		0x3900,
		0x1F00,
		0x1F00,
		0x3900,
		0x7F00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x7F00,
		0x3100,
		0x1F00,
		0x1F00,
		0x3100,
		0x7F00,
		0x0000,
		0x0000,
		0x2000,
		0x2000,
		0x0000,
		0x0000
	},
	{	0x7F00,		// BLUEEATERRIGHT
		0x4E00,
		0x7C00,
		0x7C00,
		0x4E00,
		0x7F00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x7F00,
		0x4600,
		0x7C00,
		0x7C00,
		0x4600,
		0x7F00,
		0x0000,
		0x0000,
		0x0200,
		0x0200,
		0x0000,
		0x0000
	},
	{	0x7F00,		// BLUEEATERDOWN
		0x4900,
		0x7F00,
		0x7F00,
		0x6300,
		0x4100,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x7F00,
		0x4900,
		0x4900,
		0x7F00,
		0x6300,
		0x4100,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x1C00,
		0x0000
	},
	{	0x0000,		// BLUEARMOURUP
		0x1C00,
		0x3E00,
		0x7F00,
		0x4900,
		0x7F00,
		0x0000,
		0x1C00,
		0x3E00,
		0x4900,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x4900,
		0x7F00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x0F00,		// BLUEARMOURLEFT
		0x1900,
		0x3F00,
		0x3F00,
		0x1900,
		0x0F00,
		0x0800,
		0x1000,
		0x3800,
		0x3800,
		0x1000,
		0x0800,
		0x0700,
		0x0100,
		0x0700,
		0x0700,
		0x0100,
		0x0700,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x7800,		// BLUEARMOURRIGHT
		0x4C00,
		0x7E00,
		0x7E00,
		0x4C00,
		0x7800,
		0x0800,
		0x0400,
		0x0E00,
		0x0E00,
		0x0400,
		0x0800,
		0x7000,
		0x4000,
		0x7000,
		0x7000,
		0x4000,
		0x7000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x7F00,		// BLUEARMOURDOWN
		0x4900,
		0x7F00,
		0x3E00,
		0x1C00,
		0x0000,
		0x0000,
		0x0000,
		0x4900,
		0x3E00,
		0x1C00,
		0x0000,
		0x7F00,
		0x4900,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x0000
	},
	{	0x0000,		// YELLOWHEADUP
		0x1C00,
		0x3E00,
		0x7F00,
		0x4900,
		0x7F00,
		0x0000,
		0x1C00,
		0x3E00,
		0x4900,
		0x4900,
		0x7F00,
		0x0000,
		0x1C00,
		0x3E00,
		0x4900,
		0x4900,
		0x7F00,
		0x0000,
		0x1C00,
		0x3E00,
		0x4900,
		0x4900,
		0x7F00
	},
	{	0x0F00,		// YELLOWHEADLEFT
		0x1900,
		0x3F00,
		0x3F00,
		0x1900,
		0x0F00,
		0x0F00,
		0x1100,
		0x3F00,
		0x3F00,
		0x1100,
		0x0F00,
		0x0F00,
		0x1100,
		0x3F00,
		0x3F00,
		0x1100,
		0x0F00,
		0x0F00,
		0x1100,
		0x3F00,
		0x3F00,
		0x1100,
		0x0F00
	},
	{	0x7800,		// YELLOWHEADRIGHT
		0x4C00,
		0x7E00,
		0x7E00,
		0x4C00,
		0x7800,
		0x7800,
		0x4400,
		0x7E00,
		0x7E00,
		0x4400,
		0x7800,
		0x7800,
		0x4400,
		0x7E00,
		0x7E00,
		0x4400,
		0x7800,
		0x7800,
		0x4400,
		0x7E00,
		0x7E00,
		0x4400,
		0x7800
	},
	{	0x7F00,		// YELLOWHEADDOWN
		0x4900,
		0x7F00,
		0x3E00,
		0x1C00,
		0x0000,
		0x7F00,
		0x4900,
		0x4900,
		0x3E00,
		0x1C00,
		0x0000,
		0x7F00,
		0x4900,
		0x4900,
		0x3E00,
		0x1C00,
		0x0000,
		0x7F00,
		0x4900,
		0x4900,
		0x3E00,
		0x1C00,
		0x0000
	},
	{	0x0000,		// YELLOWTONGUEUP
		0x1C00,
		0x3E00,
		0x7F00,
		0x4900,
		0x7F00,
		0x0000,
		0x1C00,
		0x3E00,
		0x4900,
		0x4900,
		0x7F00,
		0x0000,
		0x1C00,
		0x3E00,
		0x4900,
		0x4900,
		0x7F00,
		0x1C00,
		0x1C00,
		0x3E00,
		0x4900,
		0x4900,
		0x7F00
	},
	{	0x0F00,		// YELLOWTONGUELEFT
		0x1900,
		0x3F00,
		0x3F00,
		0x1900,
		0x0F00,
		0x0F00,
		0x1100,
		0x3F00,
		0x3F00,
		0x1100,
		0x0F00,
		0x0F00,
		0x1100,
		0x3F00,
		0x3F00,
		0x1100,
		0x0F00,
		0x0F00,
		0x1100,
		0x7F00,
		0x7F00,
		0x1100,
		0x0F00
	},
	{	0x7800,		// YELLOWTONGUERIGHT
		0x4C00,
		0x7E00,
		0x7E00,
		0x4C00,
		0x7800,
		0x7800,
		0x4400,
		0x7E00,
		0x7E00,
		0x4400,
		0x7800,
		0x7800,
		0x4400,
		0x7E00,
		0x7E00,
		0x4400,
		0x7800,
		0x7800,
		0x4400,
		0x7F00,
		0x7F00,
		0x4400,
		0x7800
	},
	{	0x7F00,		// YELLOWTONGUEDOWN
		0x4900,
		0x7F00,
		0x3E00,
		0x1C00,
		0x0000,
		0x7F00,
		0x4900,
		0x4900,
		0x3E00,
		0x1C00,
		0x0000,
		0x7F00,
		0x4900,
		0x4900,
		0x3E00,
		0x1C00,
		0x0000,
		0x7F00,
		0x4900,
		0x4900,
		0x3E00,
		0x1C00,
		0x1C00
	},
	{	0x4100,		// YELLOWEATERUP
		0x6300,
		0x7F00,
		0x7F00,
		0x4900,
		0x7F00,
		0x4100,
		0x6300,
		0x7F00,
		0x4900,
		0x4900,
		0x7F00,
		0x4100,
		0x6300,
		0x7F00,
		0x4900,
		0x4900,
		0x7F00,
		0x4100,
		0x7F00,
		0x7F00,
		0x4900,
		0x4900,
		0x7F00
	},
	{	0x7F00,		// YELLOWEATERLEFT
		0x3900,
		0x1F00,
		0x1F00,
		0x3900,
		0x7F00,
		0x7F00,
		0x3100,
		0x1F00,
		0x1F00,
		0x3100,
		0x7F00,
		0x7F00,
		0x3100,
		0x1F00,
		0x1F00,
		0x3100,
		0x7F00,
		0x7F00,
		0x3100,
		0x3F00,
		0x3F00,
		0x3100,
		0x7F00
	},
	{	0x7F00,		// YELLOWEATERRIGHT
		0x4E00,
		0x7C00,
		0x7C00,
		0x4E00,
		0x7F00,
		0x7F00,
		0x4600,
		0x7C00,
		0x7C00,
		0x4600,
		0x7F00,
		0x7F00,
		0x4600,
		0x7C00,
		0x7C00,
		0x4600,
		0x7F00,
		0x7F00,
		0x4600,
		0x7E00,
		0x7E00,
		0x4600,
		0x7F00
	},
	{	0x7F00,		// YELLOWEATERDOWN
		0x4900,
		0x7F00,
		0x7F00,
		0x6300,
		0x4100,
		0x7F00,
		0x4900,
		0x4900,
		0x7F00,
		0x6300,
		0x4100,
		0x7F00,
		0x4900,
		0x4900,
		0x7F00,
		0x6300,
		0x4100,
		0x7F00,
		0x4900,
		0x4900,
		0x7F00,
		0x7F00,
		0x4100
	},
	{	0x0000,		// YELLOWARMOURUP
		0x1C00,
		0x3E00,
		0x7F00,
		0x4900,
		0x7F00,
		0x0000,
		0x1C00,
		0x3E00,
		0x4900,
		0x4900,
		0x7F00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x4900,
		0x7F00,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x4900,
		0x7F00
	},
	{	0x0F00,		// YELLOWARMOURLEFT
		0x1900,
		0x3F00,
		0x3F00,
		0x1900,
		0x0F00,
		0x0F00,
		0x1100,
		0x3F00,
		0x3F00,
		0x1100,
		0x0F00,
		0x0700,
		0x0100,
		0x0700,
		0x0700,
		0x0100,
		0x0700,
		0x0700,
		0x0100,
		0x0700,
		0x0700,
		0x0100,
		0x0700
	},
	{	0x7800,		// YELLOWARMOURRIGHT
		0x4C00,
		0x7E00,
		0x7E00,
		0x4C00,
		0x7800,
		0x7800,
		0x4400,
		0x7E00,
		0x7E00,
		0x4400,
		0x7800,
		0x7000,
		0x4000,
		0x7000,
		0x7000,
		0x4000,
		0x7000,
		0x7000,
		0x4000,
		0x7000,
		0x7000,
		0x4000,
		0x7000
	},
	{	0x7F00,		// YELLOWARMOURDOWN
		0x4900,
		0x7F00,
		0x3E00,
		0x1C00,
		0x0000,
		0x7F00,
		0x4900,
		0x4900,
		0x3E00,
		0x1C00,
		0x0000,
		0x7F00,
		0x4900,
		0x0000,
		0x0000,
		0x0000,
		0x0000,
		0x7F00,
		0x4900,
		0x0000,
		0x0000,
		0x0000,
		0x0000
}	};

UWORD chip JGrafixData[3264] =
{	// Plane 0
		0x0000,0x0300,0x0000,0x0030,0x000C,0xF0FF,0xFC3F,0x0000,0x61E1,0xE001,0xE1F8,0x0000,0x0678,0x0078,0x7879,0x807F,
		0x0000,0x0C00,0x0030,0x00C0,0x003C,0x3C3F,0xF0F0,0xF000,0x7878,0x7807,0x8787,0x8000,0x1E1E,0x01E1,0xE1E7,0x807F,
		0x0000,0x3000,0x000C,0x0300,0x00CF,0x0F0F,0xC3C3,0xCC00,0x1E1E,0x1E1E,0x1E1E,0x6000,0x6787,0x8787,0x879F,0x807F,
		0x0300,0xC300,0x0003,0x0C30,0x0030,0x0000,0x0001,0x3C00,0x0780,0x0000,0x0009,0xE000,0x19E1,0xFE1E,0x1E7F,0x807F,
		0x03C3,0x0F00,0x0030,0xF0F0,0x0F00,0x0000,0x0000,0xF300,0x6180,0x0000,0x0007,0x9807,0x8600,0x0000,0x01FF,0x807F,
		0x00F0,0x3C00,0x003C,0x03C0,0x03C0,0xCC00,0x0CC0,0x4300,0x7806,0x6000,0x6642,0x1801,0xE000,0x0000,0x007F,0x807F,
		0x0038,0x7000,0x000F,0x0700,0x00E1,0x3300,0x3300,0x0F00,0x1E09,0x9801,0x9980,0x7806,0x7019,0x8001,0x999F,0x807F,
		0x0308,0x4300,0x0003,0x8430,0x0C20,0xCCC0,0xCC08,0x3C00,0x0706,0x6606,0x6641,0xE001,0x9066,0x6000,0x6667,0x807F,
		0x03C0,0x0F00,0x0030,0x80F0,0x0F01,0x3333,0x3030,0x7000,0x6109,0x9999,0x99C3,0x8006,0x6099,0x9800,0x1999,0x807F,
		0x00F0,0x3C00,0x003C,0x03C0,0x03C0,0xCF00,0x0CC8,0x4300,0x780E,0x6000,0x07C2,0x1807,0x9067,0x8000,0x0000,0x007F,
		0x0038,0x7000,0x000F,0x0700,0x00E1,0x3C00,0x0330,0x0F00,0x1E0E,0x6000,0x07C0,0x6007,0xE086,0x0000,0x0000,0x007F,
		0x0308,0x4300,0x0003,0x8430,0x0C20,0x3330,0xCCF8,0x3F00,0x0709,0xE666,0x79C1,0x9807,0x9019,0x981E,0x1F80,0x007F,
		0x03C0,0x0F03,0x0030,0x80F0,0x0F00,0xCCC0,0x3338,0x7F00,0x6107,0x9981,0x9E42,0x7806,0x6066,0x6078,0x7878,0x007F,
		0x03F0,0x3C03,0x0C3C,0x03F0,0x0FC1,0x3300,0x0CC8,0x7F00,0x780E,0x6660,0x6780,0x1801,0x9019,0x81E1,0xE1E6,0x007F,
		0x03F8,0x7333,0x0C0F,0x07F0,0x0FE0,0x0000,0x0000,0x7F00,0x7E00,0x0000,0x0003,0xE006,0x7800,0x0000,0x019E,0x007F,
		0x03F8,0x4C33,0x0CF3,0x87F0,0x0FE0,0x0000,0x0000,0x3F00,0x7F00,0x0000,0x0000,0x0007,0xFE00,0x0000,0x0079,0x807F,
		0x03F8,0x3330,0x0CCC,0x87F0,0x0FC0,0xCC00,0x0330,0x0F00,0x7F06,0x6600,0x6601,0xE001,0xF860,0x0006,0x6021,0x807F,
		0x03F0,0x4F30,0x00C3,0x03F0,0x0F01,0x3300,0x0CC8,0x4300,0x7E09,0x9981,0x9802,0x7801,0xE1E1,0x8019,0x9807,0x807F,
		0x03C0,0x3300,0x00CF,0x00F0,0x0C20,0xCCC0,0x3330,0x7000,0x7806,0x6666,0x6001,0x9800,0x0787,0xE066,0x641E,0x007F,
		0x0308,0x4300,0x300F,0x8430,0x00E0,0x3330,0xCCC8,0x3C00,0x6109,0x9999,0x8040,0x6000,0x061E,0x1999,0x9C38,0x007F,
		0x0038,0x300C,0x0C0C,0x0700,0x03C1,0x0C00,0x0338,0x0F00,0x0706,0x6000,0x0182,0x1800,0x0000,0x0000,0x7C20,0x007F,
		0x00F0,0x700F,0x3C00,0x83C0,0x0F01,0xC000,0x00F8,0x4300,0x1E09,0x8000,0x0643,0x8000,0x0000,0x0007,0x9C00,0x007F,
		0x03C0,0x4033,0x3300,0x80F0,0x0C21,0xF000,0x03F8,0x7000,0x7806,0x6000,0x1981,0xE006,0x1E1E,0x0066,0x6420,0x007F,
		0x0308,0x00CC,0x0CC0,0x0430,0x00E0,0xFC00,0x03F0,0x7C00,0x6109,0x8000,0x0640,0x7801,0x8787,0x8019,0x9818,0x007F,
		0x0038,0x0C30,0x030C,0x0700,0x03C0,0x3C00,0x03C0,0x0F00,0x0706,0x6000,0x1982,0x1800,0x61E1,0xE006,0x6026,0x007F,
		0x00F0,0x3300,0x003C,0x03C0,0x0F01,0x0C00,0x0308,0x4300,0x1E09,0x8000,0x0643,0x8000,0x1800,0x0000,0x0079,0x807F,
		0x03C0,0xCC00,0x0033,0x00F0,0x0C03,0xC000,0x003C,0xF000,0x7806,0x6000,0x1981,0xE000,0x0000,0x0000,0x019F,0x807F,
		0x0300,0xF300,0x000C,0x0C30,0x0003,0xF000,0x00F0,0xFC00,0x6019,0x8000,0x0606,0x7800,0x0078,0x7F87,0x8666,0x007F,
		0x0000,0x3C00,0x0030,0x0300,0x0000,0xFC00,0x03C0,0x3F00,0x0006,0x6000,0x1801,0x9800,0x01E1,0xE1E1,0xE19E,0x007F,
		0x0000,0x0F00,0x0000,0x00C0,0x0000,0x3C00,0x0300,0x0F00,0x0001,0x8000,0x0000,0x6000,0x0787,0x8078,0x7878,0x007F,
		0x0000,0x0300,0x0000,0x0030,0x0000,0x0C00,0x0000,0x0300,0x0000,0x6000,0x0000,0x1800,0x1E1E,0x001E,0x1F80,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x7FFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFF7F,
		0x6EC3,0x1E23,0x0BBF,0x83C7,0xFFE1,0x861F,0xE0BB,0x0FF1,0xC35D,0x7087,0x0870,0xFB0E,0x31C3,0x5FF0,0xD630,0xC37F,
		0x6EBE,0xE9F6,0xE9BF,0xF7F7,0xFFDF,0x75EF,0xFBBA,0xFFEE,0xBAAA,0xAEBA,0xEBAF,0xF6F9,0xEEBA,0xAFEE,0xAB6F,0xBB7F,
		0x758E,0x1E76,0xEABF,0xE7F7,0xFFC7,0x741F,0xFB82,0x3FEF,0xBAAA,0xAEBA,0xE863,0xEE3E,0x6FBA,0xAFE0,0xAB68,0x837F,
		0x73BE,0xDBB6,0xEB3F,0xBBF7,0xFFDF,0x75BF,0xFBBA,0xFFEE,0xBAEB,0xAEBA,0xEB6F,0xDEFB,0xAEBA,0xEFEE,0xBB6E,0xBB7F,
		0x7782,0xC863,0x1BBF,0xC642,0xFFDF,0x8DCF,0xFBBA,0x0FF1,0xC2EB,0xB187,0x1B20,0xBE08,0x71C6,0xEFEE,0xBA30,0xBB7F,
		0x7FFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFF7F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x00FF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFE00,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x00C3,0x77F8,0x6BB8,0x6177,0xFF18,0x6105,0xD843,0x8600,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x00DD,0x77F7,0x55B7,0xDD37,0xFCF7,0x5FDD,0xD75D,0x7E00,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x00C3,0x87F0,0x55B4,0x4157,0xFF37,0x47DD,0x5043,0x1E00,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x00DD,0xF7F7,0x5DB7,0x5D67,0xFDD7,0x5FDD,0x5757,0x7E00,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x00C3,0x0FF7,0x5DB8,0x5D77,0xFC38,0xDFDE,0xB759,0x0600,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x00FF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFFFF,0xFE00,0x0000,0x0000,0x0000,0x007F,
	// Plane 1
		0x00FF,0xFC00,0x000F,0xFFC0,0x0000,0x0FFF,0xFC03,0x0000,0x1FE0,0x1FFF,0xE018,0x0000,0x0007,0xFFF8,0x07F8,0x0000,
		0x033F,0xF000,0x0003,0xFF00,0x003C,0x03FF,0xF00F,0xC000,0x07F8,0x07FF,0x807E,0x0000,0x1E01,0xFFE0,0x1FE1,0x8000,
		0x03CF,0xC000,0x0030,0xFC00,0x003F,0x00FF,0xC03F,0xC000,0x61FE,0x01FE,0x01FE,0x0000,0x1F80,0x7F80,0x7F87,0x8000,
		0x03F3,0x0300,0x003C,0x3030,0x03C8,0x0000,0x0001,0x3C00,0x7840,0x0000,0x0009,0xE001,0xE7E0,0x1E01,0xFE1F,0x8000,
		0x03FF,0x0F00,0x003F,0x30F0,0x03F0,0x0000,0x0000,0xFF00,0x7E00,0x0000,0x0007,0xF801,0xF800,0x0000,0x007F,0x8000,
		0x00F8,0x3F00,0x003F,0x83F0,0x03E1,0xC3FF,0xFC30,0x7C00,0x7F0E,0x1FFF,0xE183,0xE001,0xF800,0x0000,0x001F,0x8000,
		0x0038,0x7F00,0x000F,0x87F0,0x00E1,0xF0FF,0xF0F8,0x7000,0x1F0F,0x87FF,0x8603,0x8000,0x7078,0x7FFF,0x8787,0x8000,
		0x0008,0x7C00,0x0003,0x87C0,0x0021,0xFC3F,0xC3F8,0x4000,0x0707,0xE1FE,0x1842,0x0006,0x10FE,0x1FFF,0xE1E1,0x8000,
		0x0000,0x7000,0x0000,0x8700,0x0000,0xFF0F,0x0FF0,0x0000,0x0101,0xF878,0x61C0,0x0007,0x807F,0x87FF,0xF878,0x0000,
		0x0300,0x4000,0x0000,0x0400,0x0C00,0x3F00,0x0FC0,0x0300,0x0000,0x6000,0x07C0,0x1807,0xE01F,0x8000,0x0000,0x0000,
		0x03C0,0x0000,0x0030,0x0000,0x0F01,0xCC00,0x0308,0x0F00,0x6000,0x6000,0x1FC0,0x7807,0xE0E7,0x8000,0x0000,0x0000,
		0x03F0,0x0300,0xC03C,0x0030,0x0FC1,0x3F0F,0x0FF8,0x3F00,0x7801,0x9E18,0x67C1,0xE007,0x809F,0x87FE,0x0180,0x0000,
		0x03F8,0x0F00,0xC03F,0x00F0,0x0FE0,0xFC3F,0xC3F8,0x7F00,0x7E06,0x787E,0x19C3,0x8006,0x107E,0x1FF8,0x07E0,0x0000,
		0x03F8,0x3F0C,0xCC3F,0x83F0,0x0FE1,0xF0FF,0xF0F8,0x7F00,0x7F09,0xE1FF,0x8642,0x1800,0x7078,0x7FE0,0x1FE0,0x0000,
		0x03F8,0x7C3C,0xCF0F,0x87F0,0x0FE0,0x0000,0x0000,0x7F00,0x7F00,0x0000,0x0003,0xE001,0xF800,0x0000,0x019E,0x0000,
		0x03F8,0x703C,0xCF03,0x87F0,0x0FE0,0x0000,0x0000,0x7F00,0x7F00,0x0000,0x0001,0x8001,0xE000,0x0000,0x007F,0x8000,
		0x03F8,0x433C,0x0F00,0x87F0,0x0FC1,0xC3FF,0xFC38,0x7F00,0x7F07,0x87FF,0xE181,0x8001,0x87E0,0x7FFE,0x183E,0x0000,
		0x03F0,0x0C30,0x0300,0x07F0,0x0F00,0xF0FF,0xF0F0,0x3F00,0x7E09,0xE1FF,0x8642,0x0001,0x9FE0,0x7FF8,0x6038,0x0000,
		0x03C0,0x3C00,0x000C,0x07F0,0x0C01,0x3C3F,0xC3C8,0x0F00,0x780E,0x787E,0x1983,0x8000,0x7F80,0x1FE1,0x8420,0x0000,
		0x0300,0x7C00,0x000F,0x83F0,0x0001,0xCF0F,0x0F38,0x0300,0x6007,0x9E18,0x6603,0xE000,0x0001,0x8786,0x1C00,0x0000,
		0x0000,0x4C0C,0x3C0F,0x80F0,0x0021,0xF000,0x00F8,0x0000,0x0001,0xE000,0x1841,0xF800,0x0000,0x0001,0x9C00,0x0000,
		0x0008,0x303F,0x3C03,0x0030,0x00E1,0xFC00,0x03F8,0x4000,0x0108,0x6000,0x01C0,0x7800,0x0000,0x0007,0xE420,0x0000,
		0x0038,0x400F,0x30C0,0x0000,0x03E1,0xFC00,0x03F8,0x7000,0x070E,0x0000,0x0780,0x1801,0xFE01,0xFF87,0xF818,0x0000,
		0x00F8,0x03C0,0x03C0,0x0400,0x0FE0,0xFC00,0x03F0,0x7C00,0x1F07,0x8000,0x1E00,0x0000,0x7F80,0x7FE1,0xFC06,0x0000,
		0x03F8,0x03F0,0x0300,0x0700,0x0FC0,0x3C00,0x03C0,0x7F00,0x7F01,0xE000,0x1842,0x0000,0x1FE0,0x1FF8,0x7821,0x8000,
		0x03F0,0x30C0,0x0003,0x07C0,0x0F00,0x0C00,0x0300,0x3F00,0x7E08,0x6000,0x01C3,0x8000,0x0600,0x0000,0x0078,0x0000,
		0x03C3,0x3C00,0x000F,0x3FF0,0x0C0C,0x0000,0x0003,0x0F00,0x787E,0x0000,0x079F,0xE000,0x0600,0x0000,0x007E,0x0000,
		0x030F,0x0F00,0x003C,0xF3F0,0x003C,0x0000,0x000F,0x0300,0x61E7,0x8000,0x1E79,0xF800,0x1FF8,0x0780,0x7E1E,0x0000,
		0x003F,0xC300,0x0033,0xFCF0,0x00FF,0x0000,0x003F,0xC000,0x07F9,0xE000,0x19FE,0x7800,0x7FE0,0x1FE0,0x1F80,0x0000,
		0x00FF,0xF000,0x000F,0xFF30,0x03FF,0xC000,0x00FF,0xF000,0x1FFE,0x6000,0x07FF,0x9801,0xFF80,0x7FF8,0x07E0,0x0000,
		0x03FF,0xFC00,0x003F,0xFFC0,0x0FFF,0xF000,0x03FF,0xFC00,0x7FFF,0x8000,0x1FFF,0xE007,0xFE01,0xFFFE,0x0180,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	// Plane 2
		0x03FF,0xFC00,0x003F,0xFFC0,0x0003,0xFFFF,0xFC00,0x0000,0x001F,0xFFFF,0xE000,0x0000,0x01FF,0xFFF8,0x0006,0x0000,
		0x00FF,0xF300,0x000F,0xFF30,0x0003,0xFFFF,0xF000,0x3000,0x0007,0xFFFF,0x8001,0x8000,0x01FF,0xFFE0,0x0019,0x8000,
		0x003F,0xCF00,0x0003,0xFCF0,0x0000,0xFFFF,0xC000,0x3C00,0x0001,0xFFFE,0x0001,0xE000,0x007F,0xFF80,0x0067,0x8000,
		0x000F,0x3C00,0x0000,0xF3C0,0x0000,0x0000,0x0000,0xC000,0x0000,0x0000,0x0006,0x0000,0x001F,0xFE00,0x019F,0x8000,
		0x0003,0xF000,0x0000,0x3F00,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,0x8000,
		0x0300,0x4000,0x0000,0x0400,0x0C01,0x3FFF,0xFC00,0x0000,0x0001,0xFFFF,0xE000,0x0006,0x0000,0x0000,0x019F,0x8000,
		0x03C0,0x0000,0x0030,0x0000,0x0F00,0xCFFF,0xF030,0x0000,0x6000,0x7FFF,0x8000,0x0007,0x8067,0xFFFF,0x8067,0x8000,
		0x03F0,0x0000,0x003C,0x0000,0x0FC0,0x33FF,0xC0C0,0x0000,0x7808,0x1FFE,0x0040,0x0007,0xE019,0xFFFF,0xE019,0x8000,
		0x03F8,0x0000,0x003F,0x0000,0x0FE0,0x0CFF,0x0308,0x0000,0x7E0E,0x07F8,0x01C0,0x0007,0xF006,0x7FFF,0xF806,0x0000,
		0x03F8,0x0000,0x003F,0x8000,0x0FE0,0x0000,0x0038,0x0300,0x7F0F,0x8000,0x07C0,0x1807,0xF000,0x0000,0x0000,0x0000,
		0x03F8,0x0000,0x003F,0x8000,0x0FE1,0xF000,0x00F8,0x0F00,0x7F0F,0x8000,0x1FC0,0x7807,0xE0F8,0x0000,0x0000,0x0000,
		0x03F8,0x0300,0xC03F,0x8030,0x0FE1,0xC0FF,0xF0F8,0x3F00,0x7F0E,0x01FF,0x9FC1,0xF807,0x80E0,0x7FFE,0x0000,0x0000,
		0x03F8,0x0F03,0xF03F,0x80F0,0x0FE1,0x03FF,0xFC38,0x7F00,0x7F08,0x07FF,0xE7C3,0xF806,0x0081,0xFFF8,0x0018,0x0000,
		0x03F8,0x3F0F,0xF03F,0x83F0,0x0FE0,0x0FFF,0xFF08,0x7F00,0x7F00,0x1FFF,0xF9C3,0xE000,0x0007,0xFFE0,0x001E,0x0000,
		0x03F8,0x7F3F,0xF00F,0x87F0,0x0FE0,0x0000,0x0000,0x7F00,0x7F00,0x0000,0x0000,0x0000,0x0000,0x0000,0x0060,0x0000,
		0x03F8,0x7F3F,0xF003,0x87F0,0x0FE0,0x0000,0x0000,0x7F00,0x7F00,0x0000,0x0002,0x0006,0x0600,0x0000,0x0000,0x0000,
		0x03F8,0x7F3C,0x0000,0x87F0,0x0FC0,0x3FFF,0xFFC0,0x7F00,0x7F08,0x07FF,0xE001,0xE000,0x181F,0xFFFE,0x0000,0x0000,
		0x03F0,0x7030,0x0000,0x07F0,0x0F00,0x0FFF,0xFF00,0x7F00,0x7E06,0x01FF,0x8042,0x1800,0x601F,0xFFF8,0x0000,0x0000,
		0x03C0,0x4C00,0x000C,0x07F0,0x0C00,0x03FF,0xFC00,0x7F00,0x7801,0x807E,0x01C3,0x8000,0x007F,0xFFE0,0x0400,0x0000,
		0x0300,0x0003,0x000F,0x87F0,0x0000,0x00FF,0xF000,0x7F00,0x6000,0x6018,0x07C3,0xE000,0x01FF,0xFF80,0x1C00,0x0000,
		0x0000,0x3003,0x000F,0x87F0,0x0000,0x0000,0x0000,0x7F00,0x0000,0x0000,0x1FC3,0xF800,0x0000,0x0000,0x1C00,0x0000,
		0x0000,0x0000,0x0303,0x87F0,0x0000,0x0000,0x0000,0x3F00,0x0008,0x0000,0x1FC3,0xF800,0x0000,0x0000,0x0420,0x0000,
		0x0000,0x4000,0x0FC0,0x87F0,0x0000,0x0000,0x0000,0x0F00,0x000E,0x0000,0x1F83,0xF800,0x01FF,0xFFF9,0x8038,0x0000,
		0x0000,0x03C0,0x0FC0,0x03F0,0x0001,0x0000,0x0008,0x0300,0x000F,0x8000,0x1E03,0xF806,0x007F,0xFFFE,0x603E,0x0000,
		0x0000,0x0FF0,0x0300,0x00F0,0x0021,0xC000,0x0038,0x0000,0x000F,0xE000,0x1801,0xF807,0x801F,0xFFFF,0x981F,0x8000,
		0x0008,0x0FC0,0x0000,0x0030,0x00E1,0xF000,0x00F8,0x0000,0x0107,0xE000,0x0000,0x7807,0xE000,0x0000,0x0007,0x8000,
		0x003F,0x0300,0x0000,0xF000,0x03FF,0xFC00,0x03FF,0x0000,0x07E1,0xE000,0x0078,0x1807,0xFE00,0x0000,0x0180,0x0000,
		0x00FC,0x0000,0x0003,0xC000,0x0FF0,0xFC00,0x03FC,0x0000,0x1F80,0x6000,0x01E0,0x0007,0xF807,0xFF80,0x0060,0x0000,
		0x03F0,0x0000,0x000F,0x0000,0x0FC0,0x3C00,0x03F0,0x0000,0x7E00,0x0000,0x0780,0x0007,0xE01F,0xFFE0,0x0018,0x0000,
		0x03C0,0x0000,0x003C,0x0000,0x0F00,0x0C00,0x03C0,0x0000,0x7800,0x0000,0x1E00,0x0007,0x807F,0xFFF8,0x0000,0x0000,
		0x0300,0x0000,0x0030,0x0000,0x0C00,0x0000,0x0300,0x0000,0x6000,0x0000,0x1800,0x0006,0x01FF,0xFFFE,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,
	// Plane 3
		0x0000,0x0300,0x0000,0x0030,0x0000,0x0000,0x03FC,0x0000,0x0000,0x0000,0x1FE0,0x0000,0x0000,0x0007,0xFFFF,0x807F,
		0x0000,0x0F00,0x0000,0x00F0,0x0000,0x0000,0x0FFF,0xC000,0x0000,0x0000,0x7FFE,0x0000,0x0000,0x001F,0xFFFE,0x007F,
		0x0000,0x3F00,0x0000,0x03F0,0x0000,0x0000,0x3FFF,0xF000,0x0000,0x0001,0xFFFF,0x8000,0x0000,0x007F,0xFFF8,0x007F,
		0x0000,0xFF00,0x0000,0x0FF0,0x0000,0x0000,0x0001,0xFC00,0x0000,0x0000,0x000F,0xE000,0x0000,0x01FF,0xFFE0,0x007F,
		0x0000,0xFF00,0x0000,0x0FF0,0x0000,0x0000,0x0000,0xFC00,0x0000,0x0000,0x0007,0xE000,0x0000,0x0000,0x0180,0x007F,
		0x0000,0x7F00,0x0000,0x07F0,0x0000,0x0000,0x03F8,0x7F00,0x0000,0x0000,0x1FC3,0xF800,0x0000,0x0000,0x01E0,0x007F,
		0x0000,0x7F00,0x0000,0x07F0,0x0001,0x0000,0x0FC0,0x7F00,0x0000,0x0000,0x7FC3,0xF800,0x0000,0x0000,0x7FF8,0x007F,
		0x0000,0x7F00,0x0000,0x07F0,0x0001,0xC000,0x3F00,0x7F00,0x0000,0x0001,0xFF83,0xF800,0x00E0,0x0000,0x1FFE,0x007F,
		0x0000,0x7F00,0x0000,0x07F0,0x0001,0xF000,0xFC00,0x7F00,0x0000,0x0007,0xFE03,0xF800,0x00F8,0x0000,0x07FF,0x807F,
		0x0000,0x7F00,0x0000,0x07F0,0x0001,0xFC00,0x0000,0x7C00,0x0000,0x0000,0x1803,0xE000,0x00FE,0x0000,0x0000,0x007F,
		0x0000,0x7F00,0x0000,0x07F0,0x0000,0x0000,0x0000,0x7000,0x0000,0x0000,0x0003,0x8000,0x1000,0x0000,0x0000,0x007F,
		0x0000,0x7C00,0x0000,0x07C0,0x0000,0x0000,0x0000,0x4000,0x0000,0x0000,0x0002,0x0000,0x7000,0x0001,0xFE00,0x007F,
		0x0000,0x7000,0x3000,0x0700,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0001,0xF000,0x0007,0xFFE0,0x007F,
		0x0000,0x4000,0x3C00,0x0400,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0007,0xF000,0x001F,0xFFF8,0x007F,
		0x0000,0x0000,0x3F30,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0007,0xF800,0x0000,0x01FE,0x007F,
		0x0000,0x00C0,0x3FFC,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0001,0xF800,0x0000,0x007E,0x007F,
		0x0000,0x00C0,0x0FFF,0x0000,0x0020,0x0000,0x0000,0x0000,0x000F,0xF800,0x1FC2,0x0001,0xE000,0x0001,0xF83F,0x807F,
		0x0008,0x03C0,0x03FF,0x8000,0x00E0,0x0000,0x0000,0x0000,0x010F,0xFE00,0x7F81,0xE000,0x0000,0x0007,0xFC3F,0x807F,
		0x0038,0x03C0,0xC0F3,0x8000,0x03E0,0x0000,0x0000,0x0000,0x070F,0xFF81,0xFE00,0x7800,0x0000,0x001F,0xF83F,0x807F,
		0x00F8,0x0F03,0xC030,0x0000,0x0FE0,0x0000,0x0000,0x0000,0x1F0F,0xFFE7,0xF800,0x1800,0x0000,0x007F,0xE03F,0x807F,
		0x03F8,0x0C0F,0xC000,0x0000,0x0FE0,0x0000,0x0000,0x0000,0x7F0F,0xE000,0x0000,0x0000,0x0000,0x0001,0xE03F,0x807F,
		0x03F8,0x303F,0xC000,0x0000,0x0FE0,0x0000,0x0000,0x0000,0x7F07,0xE000,0x0000,0x0000,0x0000,0x0001,0xF81F,0x807F,
		0x03F8,0x00FF,0x0000,0x0000,0x0FE0,0x0000,0x0000,0x0000,0x7F01,0xE000,0x0040,0x0000,0x0000,0x0000,0x7C07,0x807F,
		0x03F8,0x003C,0x0030,0x0000,0x0FE0,0x0000,0x0000,0x0000,0x7F00,0x6000,0x01C0,0x0000,0x0000,0x0000,0x1C01,0x807F,
		0x03F8,0x0000,0x00FC,0x0000,0x0FE0,0x0000,0x0000,0x0000,0x7F00,0x0000,0x07C0,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x03F8,0x0000,0x00FF,0x0000,0x0FE0,0x0000,0x0000,0x0000,0x7F00,0x0000,0x1FC0,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x03FC,0x0000,0x003F,0xC000,0x0FF0,0x0000,0x0000,0x0000,0x7F80,0x0000,0x1FE0,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x03F0,0x0000,0x003F,0x0000,0x0FC0,0x0000,0x0000,0x0000,0x7E00,0x0000,0x1F80,0x0000,0x0000,0x007F,0xFF80,0x007F,
		0x03C0,0x0000,0x003C,0x0000,0x0F00,0x0000,0x0000,0x0000,0x7800,0x0000,0x1E00,0x0000,0x0000,0x001F,0xFFE0,0x007F,
		0x0300,0x0000,0x0030,0x0000,0x0C00,0x0000,0x0000,0x0000,0x6000,0x0000,0x1800,0x0000,0x0000,0x0007,0xFFE0,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0001,0xFE00,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F,
		0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x007F
};

// Animations

#define VIEWS		3
#define COLUMNS		7
#define ROWS		5

BYTE view[VIEWS][VIEWFRAMES + 1][(ROWS + 1) * (COLUMNS + 1)] =
{ { {	0,0,0,0,0,0,0,0,	// Very inefficient, I know.
	0,0,0,0,0,0,0,0,	// But they are easier to modify in
	0,0,0,1,1,0,0,0,	// this form, and it is used in a
	0,0,0,1,1,0,0,0,	// part of the program in which
	0,0,0,0,0,0,0,0,	// speed is not critical.
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,0,1,1,0,0,0,
	0,0,1,1,1,1,0,0,
	0,0,1,1,1,1,0,0,
	0,0,0,1,1,0,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,1,1,0,0,0,
	0,0,1,1,1,1,0,0,
	0,1,1,1,1,1,1,0,
	0,1,1,1,1,1,1,0,
	0,0,1,1,1,1,0,0,
	0,0,0,1,1,0,0,0
    },
    {	0,0,1,1,1,1,0,0,
	0,1,1,1,1,1,1,0,
	1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,
	0,1,1,1,1,1,1,0,
	0,0,1,1,1,1,0,0
    },
    {	0,0,1,1,1,1,0,0,
	0,1,1,1,1,1,1,0,
	1,1,1,0,0,1,1,1,
	1,1,1,0,0,1,1,1,
	0,1,1,1,1,1,1,0,
	0,0,1,1,1,1,0,0
    },
    {	0,0,1,1,1,1,0,0,
	0,1,1,0,0,1,1,0,
	1,1,0,0,0,0,1,1,
	1,1,0,0,0,0,1,1,
	0,1,1,0,0,1,1,0,
	0,0,1,1,1,1,0,0
    },
    {	0,0,1,1,1,1,0,0,
	0,1,0,0,0,0,1,0,
	1,0,0,0,0,0,0,1,
	1,0,0,0,0,0,0,1,
	0,1,0,0,0,0,1,0,
	0,0,1,1,1,1,0,0
    },
    {	0,0,1,1,1,1,0,0,
	0,1,0,0,0,0,1,0,
	1,0,0,1,1,0,0,1,
	1,0,0,1,1,0,0,1,
	0,1,0,0,0,0,1,0,
	0,0,1,1,1,1,0,0
    },
    {	0,0,1,1,1,1,0,0,
	0,1,0,1,1,0,1,0,
	1,0,0,1,1,0,0,1,
	1,0,0,1,1,0,0,1,
	0,1,0,1,1,0,1,0,
	0,0,1,1,1,1,0,0
    },
    {	0,0,1,1,1,1,0,0,
	0,1,1,1,1,1,1,0,
	1,0,1,1,1,1,0,1,
	1,0,1,1,1,1,0,1,
	0,1,1,1,1,1,1,0,
	0,0,1,1,1,1,0,0
    },
    {	0,0,1,1,1,1,0,0,
	0,1,1,1,1,1,1,0,
	1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,
	0,1,1,1,1,1,1,0,
	0,0,1,1,1,1,0,0
    },
    {	0,0,0,1,1,1,0,0,
	0,1,1,1,1,1,1,0,
	1,1,1,1,1,1,1,1,
	1,1,1,1,0,1,1,1,
	0,1,1,1,1,1,1,0,
	0,0,1,1,1,1,0,0
    },
    {	0,0,0,0,1,1,0,0,
	0,1,1,1,1,1,1,0,
	1,1,1,1,1,1,1,1,
	1,1,1,0,0,1,1,1,
	0,1,1,1,1,1,1,0,
	0,0,1,1,1,1,0,0
    },
    {	0,0,0,0,0,1,0,0,
	0,1,1,1,1,1,1,0,
	1,1,1,0,1,1,1,1,
	1,1,1,0,0,1,1,1,
	0,1,1,1,1,1,1,0,
	0,0,1,1,1,1,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,1,1,1,1,1,1,0,
	1,1,1,0,0,1,1,1,
	1,1,1,0,0,1,1,1,
	0,1,1,1,1,1,1,0,
	0,0,1,1,1,1,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,1,1,1,1,1,0,0,
	1,1,1,0,0,0,1,1,
	1,1,1,0,0,1,1,1,
	0,1,1,1,1,1,1,0,
	0,0,1,1,1,1,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,1,1,1,1,1,0,0,
	1,1,1,0,0,0,1,0,
	1,1,1,0,0,0,1,1,
	0,1,1,1,1,1,1,0,
	0,0,1,1,1,1,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,1,1,1,1,1,0,0,
	1,1,1,0,0,0,1,0,
	1,1,1,0,0,0,1,0,
	0,1,1,1,1,0,1,0,
	0,0,1,1,1,1,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,1,1,1,1,1,0,0,
	1,1,1,0,0,0,1,0,
	1,1,1,0,0,0,1,0,
	0,1,1,1,0,0,0,0,
	0,0,1,1,1,1,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,1,1,1,1,1,0,0,
	1,1,1,0,0,0,1,0,
	1,1,1,0,0,0,1,0,
	0,1,1,0,0,0,0,0,
	0,0,1,1,1,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,1,1,1,1,1,0,0,
	1,1,1,0,0,0,1,0,
	1,1,1,0,0,0,1,0,
	0,1,0,0,0,0,0,0,
	0,0,1,1,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,1,1,1,1,1,0,0,
	1,1,1,0,0,0,1,0,
	1,1,0,0,0,0,1,0,
	0,1,0,0,0,0,0,0,
	0,0,1,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,1,1,1,1,1,0,0,
	1,1,0,0,0,0,1,0,
	1,1,0,0,0,0,1,0,
	0,1,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,1,0,1,1,1,0,0,
	1,1,0,0,0,0,1,0,
	1,1,0,0,0,0,1,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,1,0,0,1,1,0,0,
	1,1,0,0,0,0,1,0,
	0,1,0,0,0,0,1,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,1,0,0,0,1,0,0,
	0,1,0,0,0,0,1,0,
	0,1,0,0,0,0,1,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,1,0,0,0,0,1,0,
	0,1,0,0,0,0,1,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,1,0,0,0,0,1,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0
  } },
  { {	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,1,1,
	0,0,0,0,0,1,0,0,
	0,0,0,0,0,1,1,1,
	0,0,0,0,1,0,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,0,0,0,1,1,0,
	0,0,0,0,1,0,0,1,
	0,0,0,0,1,1,1,1,
	0,0,0,1,0,0,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,0,0,1,1,0,0,
	0,0,0,1,0,0,1,0,
	0,0,0,1,1,1,1,0,
	0,0,1,0,0,0,0,1,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,0,1,1,0,0,0,
	0,0,1,0,0,1,0,0,
	0,0,1,1,1,1,0,0,
	0,1,0,0,0,0,1,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,1,1,0,0,0,0,
	0,1,0,0,1,0,0,1,
	0,1,1,1,1,0,0,1,
	1,0,0,0,0,1,0,1,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,1,1,0,0,0,0,1,
	1,0,0,1,0,0,1,0,
	1,1,1,1,0,0,1,0,
	0,0,0,0,1,0,1,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	1,1,0,0,0,0,1,0,
	0,0,1,0,0,1,0,1,
	1,1,1,0,0,1,0,1,
	0,0,0,1,0,1,0,1,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	1,0,0,0,0,1,0,1,
	0,1,0,0,1,0,1,0,
	1,1,0,0,1,0,1,0,
	0,0,1,0,1,0,1,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,0,0,1,0,1,0,
	1,0,0,1,0,1,0,1,
	1,0,0,1,0,1,0,1,
	0,1,0,1,0,0,0,1,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,0,1,0,1,0,0,
	0,0,1,0,1,0,1,0,
	0,0,1,0,1,0,1,0,
	1,0,1,0,1,0,1,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,1,0,1,0,0,1,
	0,1,0,1,0,1,0,1,
	0,1,0,1,0,1,0,1,
	0,1,0,1,0,1,0,1,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,1,0,1,0,0,1,0,
	1,0,1,0,1,0,1,0,
	1,0,1,0,1,0,1,0,
	1,0,1,0,1,0,1,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	1,0,1,0,0,1,0,0,
	0,1,0,1,0,1,0,1,
	0,1,0,1,0,1,0,1,
	0,1,0,1,0,1,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,1,0,0,1,0,0,1,
	1,0,1,0,1,0,1,0,
	1,0,1,0,1,0,1,0,
	1,0,1,0,1,0,0,1,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	1,0,0,1,0,0,1,1,
	0,1,0,1,0,1,0,0,
	0,1,0,1,0,1,0,1,
	0,1,0,1,0,0,1,1,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,1,0,0,1,1,1,
	1,0,1,0,1,0,0,0,
	1,0,1,0,1,0,1,1,
	1,0,1,0,0,1,1,1,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,1,0,0,1,1,1,0,
	0,1,0,1,0,0,0,0,
	0,1,0,1,0,1,1,0,
	0,1,0,0,1,1,1,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	1,0,0,1,1,1,0,0,
	1,0,1,0,0,0,0,0,
	1,0,1,0,1,1,0,0,
	1,0,0,1,1,1,0,1,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,1,1,1,0,0,0,
	0,1,0,0,0,0,0,1,
	0,1,0,1,1,0,0,1,
	0,0,1,1,1,0,1,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,1,1,1,0,0,0,1,
	1,0,0,0,0,0,1,0,
	1,0,1,1,0,0,1,1,
	0,1,1,1,0,1,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	1,1,1,0,0,0,1,1,
	0,0,0,0,0,1,0,0,
	0,1,1,0,0,1,1,1,
	1,1,1,0,1,0,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	1,1,0,0,0,1,1,0,
	0,0,0,0,1,0,0,1,
	1,1,0,0,1,1,1,1,
	1,1,0,1,0,0,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	1,0,0,0,1,1,0,0,
	0,0,0,1,0,0,1,0,
	1,0,0,1,1,1,1,0,
	1,0,1,0,0,0,0,1,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,0,1,1,0,0,0,
	0,0,1,0,0,1,0,0,
	0,0,1,1,1,1,0,0,
	0,1,0,0,0,0,1,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,1,1,0,0,0,0,
	0,1,0,0,1,0,0,0,
	0,1,1,1,1,0,0,0,
	1,0,0,0,0,1,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,1,1,0,0,0,0,0,
	1,0,0,1,0,0,0,0,
	1,1,1,1,0,0,0,0,
	0,0,0,0,1,0,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	1,1,0,0,0,0,0,0,
	0,0,1,0,0,0,0,0,
	1,1,1,0,0,0,0,0,
	0,0,0,1,0,0,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	1,0,0,0,0,0,0,0,
	0,1,0,0,0,0,0,0,
	1,1,0,0,0,0,0,0,
	0,0,1,0,0,0,0,0,
	0,0,0,0,0,0,0,0
  } },
  { {	0,0,0,1,1,0,0,0,
	0,0,0,0,0,0,0,0,
	1,0,0,0,0,0,0,1,
	1,0,0,0,0,0,0,1,
	0,0,0,0,0,0,0,0,
	0,0,0,1,1,0,0,0
    },
    {	0,0,1,1,1,1,0,0,
	1,0,0,1,1,0,0,1,
	1,1,0,0,0,0,1,1,
	1,1,0,0,0,0,1,1,
	1,0,0,1,1,0,0,1,
	0,0,1,1,1,1,0,0
    },
    {	1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1
    },
    {	1,1,1,0,0,1,1,1,
	1,1,1,1,1,1,1,1,
	0,1,1,1,1,1,1,0,
	0,1,1,1,1,1,1,0,
	1,1,1,1,1,1,1,1,
	1,1,1,0,0,1,1,1
    },
    {	1,1,0,0,0,0,1,1,
	0,1,1,0,0,1,1,0,
	0,0,1,1,1,1,0,0,
	0,0,1,1,1,1,0,0,
	0,1,1,0,0,1,1,0,
	1,1,0,0,0,0,1,1
    },
    {	0,1,0,0,0,0,1,0,
	1,1,1,0,0,1,1,1,
	0,1,1,1,1,1,1,0,
	0,1,1,1,1,1,1,0,
	1,1,1,0,0,1,1,1,
	0,1,0,0,0,0,1,0
    },
    {	0,0,0,0,0,0,0,0,
	0,1,1,0,0,1,1,0,
	0,1,1,1,1,1,1,0,
	0,1,1,1,1,1,1,0,
	0,1,1,0,0,1,1,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,1,0,0,1,0,0,
	0,1,1,1,1,1,1,0,
	0,1,1,1,1,1,1,0,
	0,0,1,0,0,1,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,1,0,0,0,0,1,0,
	1,1,1,1,1,1,1,1,
	1,1,1,1,1,1,1,1,
	0,1,0,0,0,0,1,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,1,0,0,1,0,0,
	0,1,1,1,1,1,1,0,
	0,1,1,1,1,1,1,0,
	0,0,1,0,0,1,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,0,1,1,0,0,0,
	0,0,1,1,1,1,0,0,
	0,0,1,1,1,1,0,0,
	0,0,0,1,1,0,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,1,1,0,0,
	0,0,0,1,1,1,1,0,
	0,0,0,1,1,1,1,0,
	0,0,0,0,1,1,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,0,0,0,1,1,0,
	0,0,0,0,1,1,1,1,
	0,0,0,0,1,1,1,1,
	0,0,0,0,0,1,1,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,1,1,0,0,
	0,0,0,1,1,1,1,0,
	0,0,0,1,1,1,1,0,
	0,0,0,0,1,1,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,0,1,1,0,0,0,
	0,0,1,1,1,1,0,0,
	0,0,1,1,1,1,0,0,
	0,0,0,1,1,0,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,1,1,0,0,0,0,
	0,1,1,1,1,0,0,0,
	0,1,1,1,1,0,0,0,
	0,0,1,1,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,1,1,0,0,0,0,0,
	1,1,1,1,0,0,0,0,
	1,1,1,1,0,0,0,0,
	0,1,1,0,0,0,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,1,1,0,0,0,0,
	0,1,1,1,1,0,0,0,
	0,1,1,1,1,0,0,0,
	0,0,1,1,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,0,1,1,0,0,0,
	0,0,1,1,1,1,0,0,
	0,0,1,1,1,1,0,0,
	0,0,0,1,1,0,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,0,1,1,0,0,0,
	0,0,1,1,1,1,0,0,
	0,0,1,1,1,1,0,0,
	0,0,0,1,1,0,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,1,1,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,1,1,0,0,0,
	0,0,1,1,1,1,0,0,
	0,0,1,1,1,1,0,0,
	0,0,0,1,1,0,0,0
    },
    {	0,0,1,1,1,1,0,0,
	0,0,0,1,1,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,1,1,0,0,0,
	0,0,1,1,1,1,0,0,
	0,0,1,1,1,1,0,0
    },
    {	0,0,1,1,1,1,0,0,
	0,0,1,1,1,1,0,0,
	0,0,0,1,1,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,1,1,0,0,0,
	0,0,1,1,1,1,0,0
    },
    {	0,0,0,1,1,0,0,0,
	0,0,1,1,1,1,0,0,
	0,0,1,1,1,1,0,0,
	0,0,0,1,1,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,1,1,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,0,1,1,0,0,0,
	0,0,1,1,1,1,0,0,
	0,0,1,1,1,1,0,0,
	0,0,0,1,1,0,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,1,1,0,0,0,
	0,0,0,1,1,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0
    },
    {	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0,
	0,0,0,0,0,0,0,0
} } };

struct
{	BYTE		x, y, deltax, deltay, oldx, oldy, xmemory, ymemory;
	BYTE		victor;
	BOOL		alive, moved;
	UBYTE		speed, lives, control;
	UBYTE		cause, mode, last, oldlast;
	WORD		armour, tongue, eater, ammo, bias, ice;
	BYTE		multi, nitro, power, diagonal;
	LONG		score, oldscore;
	UWORD		causewait;
	BYTE		statx, staty, colour;
} worm[4];
struct
{	BYTE		x, y, deltax, deltay, oldx, oldy;
	BOOL		alive, moved, explode;
	BYTE		speed, mode;
	UBYTE		last;
	WORD		armour, tongue, eater;
	BYTE		multi;
	LONG		score;
} orb[ORBS + 1];
struct
{	BYTE		x, y, deltax, deltay, oldx, oldy, relx, rely;
	BOOL		alive, moved, visible;
} protector[4][PROTECTORS + 1];
struct
{	BYTE		x, y, last;
	BOOL		alive;
} killer[KILLERS + 1];
struct
{	BYTE		x, y, deltax, deltay;
	BOOL		alive, moved;
} killerfire[KILLERS + 1];
struct
{	BYTE		x, y, deltax, deltay, oldx, oldy;
	BOOL		alive, moved;
} frag[ORBS + 1][8];
struct
{	BYTE		x, y, oldx, oldy;
	BOOL		alive;
} bullet[POWERMAX + 1];
struct
{	BYTE		x, y, deltax, deltay, oldx, oldy;
	BOOL		alive, moved;
} missile[4];
struct
{	BYTE		x, y;
	BOOL		alive;
} teleport[TELEPORTS + 1];
struct
{	WORD		frequency;
	LONG		score;
} object[] =	{	{  20,	 100},	//	BONUS
			{  60,	 200},	//	AMMO
/* -40     common    */	{  40,	 200},	//	ARMOUR
/* 60-100  uncommon  */	{  80,	 200},	//	TONGUE
/* 120-160 rare      */	{ 100,	 100},	//	NITRO
/* 180+    very rare */	{  60,	 300},	//	BOMB
			{ 160,	 400},	//	SLAYER
			{ 140,	 500},	//	PROTECTOR
			{  60,	 300},	//	POWER
			{  60,	 400},	//	MISSILE
			{  60,	 500},	//	LIFE
			{ 180,	 500},	//	MULTIPLIER
			{ 200,	 600},	//	ICE
			{ 160,	 900},	//	EATER
			{ 140,	 500},	//	BIAS
			{  80,	 300},	//	DIAGONAL
			{ 180,	 500}	//	GROWER
		};
BYTE attr[13][8] =
{	"Score: ",
	"Lives: ",
	"Bias:  ",
	"       ",
	"Ammo:  ",
	"Power: ",
	"       ",
	"Armour:",
	"Tongue:",
	"Eater: ",
	"       ",
	"Speed: ",
	"Diag:  "
};

UBYTE eachworm[4][4][9] =
{	{	{	GREENHEADUP,		GREENHEADUP,		GREENHEADUP,
			GREENHEADLEFT,		ANYTHING,		GREENHEADRIGHT,
			GREENHEADDOWN,		GREENHEADDOWN,		GREENHEADDOWN
		},
		{	GREENEATERUP,		GREENEATERUP,		GREENEATERUP,
			GREENEATERLEFT,		ANYTHING,		GREENEATERRIGHT,
			GREENEATERDOWN,		GREENEATERDOWN,		GREENEATERDOWN
		},
		{	GREENTONGUEUP,		GREENTONGUEUP,		GREENTONGUEUP,
			GREENTONGUELEFT,	ANYTHING,		GREENTONGUERIGHT,
			GREENTONGUEDOWN,	GREENTONGUEDOWN,	GREENTONGUEDOWN
		},
		{	GREENARMOURUP,		GREENARMOURUP,		GREENARMOURUP,
			GREENARMOURLEFT,	ANYTHING,		GREENARMOURRIGHT,
			GREENARMOURDOWN,	GREENARMOURDOWN,	GREENARMOURDOWN
		}
	},
	{	{	REDHEADUP,		REDHEADUP,		REDHEADUP,
			REDHEADLEFT,		ANYTHING,		REDHEADRIGHT,
			REDHEADDOWN,		REDHEADDOWN,		REDHEADDOWN
		},
		{	REDEATERUP,		REDEATERUP,		REDEATERUP,
			REDEATERLEFT,		ANYTHING,		REDEATERRIGHT,
			REDEATERDOWN,		REDEATERDOWN,		REDEATERDOWN
		},
		{	REDTONGUEUP,		REDTONGUEUP,		REDTONGUEUP,
			REDTONGUELEFT,		ANYTHING,		REDTONGUERIGHT,
			REDTONGUEDOWN,		REDTONGUEDOWN,		REDTONGUEDOWN
		},
		{	REDARMOURUP,		REDARMOURUP,		REDARMOURUP,
			REDARMOURLEFT,		ANYTHING,		REDARMOURRIGHT,
			REDARMOURDOWN,		REDARMOURDOWN,		REDARMOURDOWN
		}
	},
	{	{	BLUEHEADUP,		BLUEHEADUP,		BLUEHEADUP,
			BLUEHEADLEFT,		ANYTHING,		BLUEHEADRIGHT,
			BLUEHEADDOWN,		BLUEHEADDOWN,		BLUEHEADDOWN
		},
		{	BLUEEATERUP,		BLUEEATERUP,		BLUEEATERUP,
			BLUEEATERLEFT,		ANYTHING,		BLUEEATERRIGHT,
			BLUEEATERDOWN,		BLUEEATERDOWN,		BLUEEATERDOWN
		},
		{	BLUETONGUEUP,		BLUETONGUEUP,		BLUETONGUEUP,
			BLUETONGUELEFT,		ANYTHING,		BLUETONGUERIGHT,
			BLUETONGUEDOWN,		BLUETONGUEDOWN,		BLUETONGUEDOWN
		},
		{	BLUEARMOURUP,		BLUEARMOURUP,		BLUEARMOURUP,
			BLUEARMOURLEFT,		ANYTHING,		BLUEARMOURRIGHT,
			BLUEARMOURDOWN,		BLUEARMOURDOWN,		BLUEARMOURDOWN
		}
	},
	{	{	YELLOWHEADUP,		YELLOWHEADUP,		YELLOWHEADUP,
			YELLOWHEADLEFT,		ANYTHING,		YELLOWHEADRIGHT,
			YELLOWHEADDOWN,		YELLOWHEADDOWN,		YELLOWHEADDOWN
		},
		{	YELLOWEATERUP,		YELLOWEATERUP,		YELLOWEATERUP,
			YELLOWEATERLEFT,	ANYTHING,		YELLOWEATERRIGHT,
			YELLOWEATERDOWN,	YELLOWEATERDOWN,	YELLOWEATERDOWN
		},
		{	YELLOWTONGUEUP,		YELLOWTONGUEUP,		YELLOWTONGUEUP,
			YELLOWTONGUELEFT,	ANYTHING,		YELLOWTONGUERIGHT,
			YELLOWTONGUEDOWN,	YELLOWTONGUEDOWN,	YELLOWTONGUEDOWN
		},
		{	YELLOWARMOURUP,		YELLOWARMOURUP,		YELLOWARMOURUP,
			YELLOWARMOURLEFT,	ANYTHING,		YELLOWARMOURRIGHT,
			YELLOWARMOURDOWN,	YELLOWARMOURDOWN,	YELLOWARMOURDOWN
}	}	};
struct
{	BYTE x, y;
} anim[4][18] =
{{	{	0, 1			},
	{	0, 1			},
	{	0, 1			},
	{	0, 1			},
	{	1, 0			},
	{	1, -1			},
	{	1, -1			},
	{	1, 1			},
	{	1, 1			},
	{	1, 0			},
	{	0, -1			},
	{	0, -1			},
	{	0, -1			},
	{	0, -1			},
	{	SENTINEL, SENTINEL	},
	{	SENTINEL, SENTINEL	},
	{	SENTINEL, SENTINEL	},
	{	SENTINEL, SENTINEL	}
},
{	{	1, 0			},
	{	1, 0			},
	{	1, 0			},
	{	1, 1			},
	{	0, 1			},
	{	0, 1			},
	{	-1, 1			},
	{	-1, 0			},
	{	-1, 0			},
	{	-1, 0			},
	{	-1, -1			},
	{	0, -1			},
	{	0, -1			},
	{	SENTINEL, SENTINEL	},
	{	SENTINEL, SENTINEL	},
	{	SENTINEL, SENTINEL	},
	{	SENTINEL, SENTINEL	},
	{	SENTINEL, SENTINEL	}
},
{	{	0, -1			},
	{	0, -1			},
	{	0, -1			},
	{	0, -1			},
	{	1, 0			},
	{	1, 0			},
	{	1, 0			},
	{	1, 0			},
	{	1, 1			},
	{	-1, 1			},
	{	-1, 0			},
	{	-1, 0			},
	{	-1, 0			},
	{	1, 1			},
	{	1, 1			},
	{	1, 0			},
	{	1, 0			},
	{	SENTINEL, SENTINEL	}
},
{	{	0, -1			},
	{	0, -1			},
	{	0, -1			},
	{	0, -1			},
	{	1, 0			},
	{	1, 1			},
	{	1, 1			},
	{	1, -1			},
	{	1, -1			},
	{	1, 0			},
	{	0, 1			},
	{	0, 1			},
	{	0, 1			},
	{	0, 1			},
	{	SENTINEL, SENTINEL	},
	{	SENTINEL, SENTINEL	},
	{	SENTINEL, SENTINEL	},
	{	SENTINEL, SENTINEL	}
}};

struct
{	BYTE		scancode;
	BYTE		player;
	BYTE		deltax;
	BYTE		deltay;
	UBYTE		special;
} key[NUMKEYS + 1] =
{	{0x0F,	1,	 0,	 0,	AMMO},		// 0
	{0x10,	0,	-1,	-1,	NULL},		// Q
	{0x11,	0,	 0,	-1,	NULL},		// W
	{0x12,	0,	 1,	-1,	NULL},		// E
	{0x19,	0,	 0,	 0,	PAUSE},		// P
	{0x20,	0,	-1,	 0,	NULL},		// A
	{0x21,	0,	 0,	 1,	NULL},		// S
	{0x22,	0,	 1,	 0,	NULL},		// D
	{0x31,	0,	-1,	 1,	NULL},		// Z
	{0x32,	0,	 1,	 1,	NULL},		// X
	{0x33,	0,	 1,	 1,	NULL},		// C
	{0x37,	0,	 0,	 0,	MUSIC},		// M
	{0x3D,	1,	-1,	-1,	NULL},		// 7
	{0x3E,	1,	 0,	-1,	NULL},		// 8
	{0x3F,	1,	 1,	-1,	NULL},		// 9
	{0x2D,	1,	-1,	 0,	NULL},		// 4
	{0x2E,	1,	 0,	 1,	NULL},		// 5
	{0x2F,	1,	 1,	 0,	NULL},		// 6
	{0x1D,	1,	-1,	 1,	NULL},		// 1
	{0x1E,	1,	 0,	 1,	NULL},		// 2
	{0x1F,	1,	 1,	 1,	NULL},		// 3
	{0x40,	0,	 0,	 0,	AMMO},		// spacebar
	{0x4A,	0,	 0,	 0,	TRAINER},	// -
	{0x4C,	1,	 0,	-1,	NULL},		// up
	{0x4D,	1,	 0,	 1,	NULL},		// down
	{0x4E,	1,	 1,	 0,	NULL},		// right
	{0x4F,	1,	-1,	 0,	NULL},		// left
	{0x45,	0,	 0,	 0,	EXIT},		// Esc
	{0x5C,	0,	 0,	 0,	TRAINER},	// /
	{0x5D,	0,	 0,	 0,	TRAINER},	// *
	{0x5E,	0,	 0,	 0,	TRAINER},	// +
	{0x5F,	0,	 0,	 0,	TRAINER}	// Help
};
struct NewMenu JNewMenu[] =
{	{	NM_TITLE,	"Project",	 0 , 0,               0, 0},
	{	 NM_ITEM,	"New",		"N", NM_ITEMDISABLED, 0, 0},
	{	 NM_ITEM,	"Revert",	"R", NM_ITEMDISABLED, 0, 0},
	{	 NM_ITEM,	"Save",		"S", NM_ITEMDISABLED, 0, 0},
	{	 NM_ITEM,	NM_BARLABEL,	 0 , 0,               0, 0},
	{	 NM_ITEM,	"Quit",		"Q", 0,               0, 0},
	{	NM_TITLE,	"Module",	 0 , 0,               0, 0},
	{	 NM_ITEM,	"Title Screen",	 0 , NM_ITEMDISABLED, 0, 0},
	{	 NM_ITEM,	"Field Editor",	 0 , 0,               0, 0},
	{	  NM_END,	NULL,		 0 , 0,               0, 0}
};
struct TextAttr Topaz8 =
{	(STRPTR) "topaz.font", 8, FS_NORMAL, FPF_ROMFONT | FPF_DESIGNED
};
struct NewGadget JNewGadget[4] =
{	{	284, 176,
		128, 13,
		"Worm _1:",
		&Topaz8,
		NULL, NULL,
		NULL,
		NULL
	},
	{	284, 192,
		128, 13,
		"Worm _2:",
		&Topaz8,
		NULL, NULL,
		NULL,
		NULL
	},
	{	284, 208,
		128, 13,
		"Worm _3:",
		&Topaz8,
		NULL, NULL,
		NULL,
		NULL
	},
	{	284, 224,
		128, 13,
		"Worm _4:",
		&Topaz8,
		NULL, NULL,
		NULL,
		NULL
}	};
UBYTE* JGadgetOptions[] =
{	(UBYTE *) "None",
	(UBYTE *) "Human",
	(UBYTE *) "Amiga",
	NULL
};
USHORT JColours[20] =
{
	// screen colours

	0x000,	// BLACK
	0xFFF,	// WHITE
	0x222,	// GREY
	0x555,
	0x22F,
	0x66F,
	0x909,
	0xB6B,	// PURPLE
	0xF00,
	0xF44,	// RED
	0x070,
	0x4E4,	// GREEN
	0x333,
	0xAAF,	// BLUE
	0x860,
	0xCC2,	/* YELLOW

	pointer colours */

	0x000,	// transparent
	0xE44,	// main pointer colour (medium-intensity)
	0x333,	// low-intensity
	0xCCC	// high-intensity
};
struct Image JImage =
{	0, 0,
	X, Y, 4,
	JImageData[0],
	0xf, 0x0,
	NULL
};
struct Image JGrafix =
{	0, 0,
	247, 51, 4,
	JGrafixData,
	0xf, 0x0,
	NULL
};
struct GamePortTrigger JTrigger =
{	GPTF_DOWNKEYS,
	65535,
	1, 1
};
struct EasyStruct JEasyStruct =
{	sizeof(struct EasyStruct),
	0,
	"Worm Wars 3.1",
	"Save field first?",
	"Yes|No"
};
UWORD JPens[] = {BLACK, WHITE, WHITE, WHITE, GREY, BLUE, BLACK, BLACK, PURPLE, (UWORD) ~0};
STRPTR objectdesc[DESCRIPTIONS + 1] =
{	"BONUS: 100 points.",
	"AMMO: 1-6 bullets.",
	"ARMOUR: Immune to most damage.",
	"TONGUE: Immune to worm-worm collisions.",
	"NITRO: 5 speeds available instead of 3.",
	"BOMB: An explosion.",
	"SLAYER: Kills orbs and killers.",
	"PROTECTOR: An orbiting companion.",
	"POWER: Thicker shots.",
	"MISSILE: A guided missile.",
	"LIFE: 1-5 lives.",
	"MULTIPLIER: Doubles all further points.",
	"ICE: Freezes everything except you.",
	"EATER: Tongue plus square-enhancement.",
	"BIAS: Several helpful things.",
	"DIAGONAL: Lets you move diagonally.",
	"GROWER: Enlarges silver and gold.",
	"TELEPORT: Reappear at other teleport.",
	"EMPTY: 1 point.",
	"SILVER: 100 points.",
	"GOLD: 500 points."
};

struct
{	BYTE deltax, deltay;
} rotate[8] =
{	{	-1, -1	},
	{	-1,  0	},
	{	-1,  1	},
	{	 0,  1	},
	{	 1,  1	},
	{	 1,  0	},
	{	 1, -1	},
	{	 0, -1	}
};
UWORD chip JGoldPointer[] =
{	0x0000, 0x0000,		// reserved

	0xF000, 0xF000,
	0x8000, 0xF000,
	0x8000, 0xF000,
	0x8000, 0xF000,
	0x8000, 0xF000,
	0x8000, 0xF000,

	0x0000, 0x0000		// reserved
};
UWORD chip JSilverPointer[] =
{	0x0000, 0x0000,		// reserved

	0xF000, 0xF000,
	0xE000, 0x9000,
	0xE000, 0x9000,
	0xE000, 0x9000,
	0xE000, 0x9000,
	0x8000, 0xF000,

	0x0000, 0x0000		// reserved
};
UWORD chip JEmptyPointer[] =
{	0x0000, 0x0000,		// reserved

	0xF000, 0x0000,
	0xE000, 0x7000,
	0xE000, 0x7000,
	0xE000, 0x7000,
	0xE000, 0x7000,
	0x8000, 0x7000,

	0x0000, 0x0000		// reserved
};
UWORD chip JBrickPointer[] =
{	0x0000, 0x0000,		// reserved

	0xF000, 0x0000,
	0x8000, 0x7000,
	0x8000, 0x7000,
	0x8000, 0x7000,
	0x8000, 0x7000,
	0x8000, 0x7000,

	0x0000, 0x0000		// reserved
};
UWORD chip JWallPointer[] =
{	0x0000, 0x0000,		// reserved

	0xF000, 0xF000,
	0xE000, 0x9000,
	0xE000, 0x9000,
	0xE000, 0x9000,
	0xE000, 0x9000,
	0x8000, 0xF000,

	0x0000, 0x0000		// reserved
};

// Must have blank line at EOF.
